﻿//-----------------------------------------------------------------------------
// ALLDAQ, a division of ALLNET GmbH
// https://www.alldaq.com
//
// Purpose:
//       This file is part of the Counter8254 project of the ALLDAQ-SDK.
//       It shows the usage of the API functions to access
//       ALLDAQ Data Acquisition Boards
//
//-----------------------------------------------------------------------------


namespace Counter8254.Utility
{
    public class ClockSourceComboBoxItem
    {
        readonly string _clockSourceName;

        public ClockSourceComboBoxItem(uint clockSource)
        {
            ClockSourceValue = clockSource;
            _clockSourceName = AdqCommon.GetCounterClockSourceName(clockSource);
        }

        public override string ToString()
        {
            return _clockSourceName;
        }

        public uint ClockSourceValue { get; }
    }
}
