﻿//-----------------------------------------------------------------------------
// ALLDAQ, a division of ALLNET GmbH
// https://www.alldaq.com
//
// Purpose:
//       This file is part of the Interrupt project of the ALLDAQ-SDK.  
//       It shows the usage of the API functions to access
//       ALLDAQ Data Acquisition Boards
// 
//-----------------------------------------------------------------------------


namespace Interrupt.ViewModels
{
    public class BitMaskEdgeItemViewModel : ViewModelBase
    {
        public BitMaskEdgeItemViewModel(int bitNumber)
        {
            BitNumber = bitNumber.ToString();
        }

        public string BitNumber { get; }

        private bool _bitRisingEdge;
        public bool BitRisingEdge
        {
            get { return _bitRisingEdge; }
            set
            {
                if (_bitRisingEdge != value)
                {
                    _bitRisingEdge = value;
                    NotifyPropertyChanged(nameof(BitRisingEdge));
                }
            }
        }

        private bool _bitFallingEdge;
        public bool BitFallingEdge
        {
            get { return _bitFallingEdge; }
            set
            {
                if (_bitFallingEdge != value)
                {
                    _bitFallingEdge = value;
                    NotifyPropertyChanged(nameof(BitFallingEdge));
                }
            }
        }
    }
}
