﻿//-----------------------------------------------------------------------------
// ALLDAQ, a division of ALLNET GmbH
// http://www.alldaq.com
//
// Purpose:
//       This file is part of the WriteBufferAO project of the ALLDAQ-SDK.  
//       It shows the usage of the API functions to access
//       ALLDAQ Data Acquisition Boards
// 
//-----------------------------------------------------------------------------

using ALLDAQ.Boards;
using System.Collections.Generic;
using WriteBufferAO.Utility;

namespace WriteBufferAO.Models
{
    public class AdqAoBoard
    {
        public AdqAoBoard(uint boardIndex, ref AdqDriver.ADQBoardInfo boardInfo)
        {
            BoardIndex = boardIndex;
            BoardName = boardInfo.BoardName;
            ModelName = AdqCommon.GetModelName(BoardName);
            BoardDisplayName = ModelName + ", Board " + BoardIndex.ToString();
        }

        public uint BoardIndex { get; }
        public string BoardName { get; }
        public string BoardDisplayName { get; }
        public string ModelName { get; }
        public List<AoModule> AoModules { get; } = new List<AoModule>();

        public void AddModule(AoModule aoModule)
        {
            AoModules.Add(aoModule);
        }
    }
}
