﻿'-----------------------------------------------------------------------------
' ALLDAQ, a division of ALLNET GmbH
' https://www.alldaq.com
'
' Purpose:
'       This file Is part of the Interrupt project of the ALLDAQ-SDK.  
'       It shows the usage of the API functions to access
'       ALLDAQ Data Acquisition Boards
' 
'-----------------------------------------------------------------------------

Public Class BitEdgeIndicatorItemViewModel
    Inherits ViewModelBase

    Public Sub New(bitNum As Integer)
        BitNumber = bitNum.ToString()
    End Sub

    Public ReadOnly Property BitNumber As String

    Private _risingEdge As Boolean
    Public Property RisingEdge As Boolean
        Get
            Return _risingEdge
        End Get
        Set
            If _risingEdge <> Value Then
                _risingEdge = Value
                NotifyPropertyChanged(NameOf(RisingEdge))
            End If
        End Set
    End Property

    Private _fallingEdge As Boolean
    Public Property FallingEdge As Boolean
        Get
            Return _fallingEdge
        End Get
        Set
            If _fallingEdge <> Value Then
                _fallingEdge = Value
                NotifyPropertyChanged(NameOf(FallingEdge))
            End If
        End Set
    End Property
End Class
