﻿'-----------------------------------------------------------------------------
' ALLDAQ, a division of ALLNET GmbH
' https://www.alldaq.com
'
' Purpose:
'       This file Is part of the Interrupt project of the ALLDAQ-SDK.  
'       It shows the usage of the API functions to access
'       ALLDAQ Data Acquisition Boards
' 
'-----------------------------------------------------------------------------

Public Class BitMaskEdgeItemViewModel
    Inherits ViewModelBase

    Public Sub New(bitNum As Integer)
        BitNumber = bitNum.ToString()
    End Sub

    Public ReadOnly Property BitNumber As String

    Private _bitRisingEdge As Boolean
    Public Property BitRisingEdge As Boolean
        Get
            Return _bitRisingEdge
        End Get
        Set
            If _bitRisingEdge <> Value Then
                _bitRisingEdge = Value
                NotifyPropertyChanged(NameOf(BitRisingEdge))
            End If
        End Set
    End Property

    Private _bitFallingEdge As Boolean
    Public Property BitFallingEdge As Boolean
        Get
            Return _bitFallingEdge
        End Get
        Set
            If _bitFallingEdge <> Value Then
                _bitFallingEdge = Value
                NotifyPropertyChanged(NameOf(BitFallingEdge))
            End If
        End Set
    End Property
End Class
