﻿'-----------------------------------------------------------------------------
' ALLDAQ, a division of ALLNET GmbH
' https://www.alldaq.com
'
' Purpose:
'       This file Is part of the Interrupt project of the ALLDAQ-SDK.  
'       It shows the usage of the API functions to access
'       ALLDAQ Data Acquisition Boards
' 
'-----------------------------------------------------------------------------

Imports System.ComponentModel

Public Class ErrorInfoViewModelBase
    Inherits ViewModelBase
    Implements IDataErrorInfo

    Protected _errorInfo As Dictionary(Of String, String) = New Dictionary(Of String, String)

    Public Overridable Function IsInputValid() As Boolean
        Return _errorInfo.Count = 0
    End Function


    Default Public ReadOnly Property Item(propertyName As String) As String Implements IDataErrorInfo.Item
        Get
            Dim value As String = String.Empty
            If _errorInfo.TryGetValue(propertyName, value) Then
                Return value
            End If
            Return Nothing
        End Get
    End Property

    Public ReadOnly Property [Error] As String Implements IDataErrorInfo.Error
        Get
            Return "ViewModel.Error"
        End Get
    End Property
End Class
