﻿'-----------------------------------------------------------------------------
' ALLDAQ, a division of ALLNET GmbH
' https://www.alldaq.com
'
' Purpose:
'       This file Is part of the WriteBufferAO project of the ALLDAQ-SDK.  
'       It shows the usage of the API functions to access
'       ALLDAQ Data Acquisition Boards
' 
'-----------------------------------------------------------------------------

Public Class ChargeDischargeWaveGenerator
    Implements ISignalGenerator

    Private Const _cycleTimesToCharge As Integer = 12

    Public ReadOnly Property GeneratorIcon As String Implements ISignalGenerator.GeneratorIcon
        Get
            Return "/WriteBufferAO;component/Images/signalExponential.png"
        End Get
    End Property

    Public ReadOnly Property GeneratorName As String Implements ISignalGenerator.GeneratorName
        Get
            Return "Charge, discharge"
        End Get
    End Property

    Public Function GetValue(cycleTime As Double, signalMinimum As Double, signalMaximum As Double) As Double Implements ISignalGenerator.GetValue
        Dim signalRange As Double = signalMaximum - signalMinimum
        If cycleTime <= 0.5 Then
            Return signalMinimum + signalRange * (1 - Math.Pow(Math.E, -cycleTime * _cycleTimesToCharge))
        End If
        Return signalMinimum + signalRange * Math.Pow(Math.E, -(cycleTime - 0.5) * _cycleTimesToCharge)
    End Function
End Class
