﻿'-----------------------------------------------------------------------------
' ALLDAQ, a division of ALLNET GmbH
' https://www.alldaq.com
'
' Purpose:
'       This file Is part of the WriteBufferAO project of the ALLDAQ-SDK.  
'       It shows the usage of the API functions to access
'       ALLDAQ Data Acquisition Boards
' 
'-----------------------------------------------------------------------------

Public Class NonReturnToZeroWaveGenerator
    Implements ISignalGenerator

    Private ReadOnly _random As Random = New Random()
    Private _value As Integer = 0

    Public ReadOnly Property GeneratorIcon As String Implements ISignalGenerator.GeneratorIcon
        Get
            Return "/WriteBufferAO;component/Images/signalNonZero.png"
        End Get
    End Property

    Public ReadOnly Property GeneratorName As String Implements ISignalGenerator.GeneratorName
        Get
            Return "Non-return-to-zero"
        End Get
    End Property

    Public Function GetValue(cycleTime As Double, signalMinimum As Double, signalMaximum As Double) As Double Implements ISignalGenerator.GetValue
        ' http://en.wikipedia.org/wiki/Non-return-to-zero
        If cycleTime = 0 Then
            _value = 1 - _random.Next(2)
        End If

        If _value > 0 Then
            Return signalMaximum
        End If
        Return signalMinimum
    End Function
End Class
