
// adqSignalGeneratorDlg.cpp : implementation file
//

#include "stdafx.h"

#include <process.h>

#define _USE_MATH_DEFINES

#include <math.h>

#include <float.h>

#include "adqSignalGenerator.h"
#include "adqSignalGeneratorDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CadqSignalGeneratorDlg dialog

const unsigned int  SIGNAL_TYPE_SINUS           = 0;

const unsigned int  SIGNAL_TYPE_TRIANGLE        = 1;

const unsigned int  SIGNAL_TYPE_SAW_TOOTH_LEFT  = 2;

const unsigned int  SIGNAL_TYPE_SAW_TOOTH_RIGHT = 3;

const unsigned int  SIGNAL_TYPE_RECTANGLE       = 4;

struct SAOSignalType
{
    unsigned int    m_uiSignallType;

    TCHAR*          m_tzSignalName;
}
const m_arrSignalTypes[5] =     {   {SIGNAL_TYPE_SINUS,              _T("Sinus") },
                                    {SIGNAL_TYPE_TRIANGLE,          _T("Triangle") },
                                    {SIGNAL_TYPE_SAW_TOOTH_LEFT,    _T("Saw-tooth left") },
                                    {SIGNAL_TYPE_SAW_TOOTH_RIGHT,   _T("Saw-tooth right") },
                                    {SIGNAL_TYPE_RECTANGLE,         _T("Rectangle") }    
                                };


CadqSignalGeneratorDlg::CadqSignalGeneratorDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CadqSignalGeneratorDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CadqSignalGeneratorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CadqSignalGeneratorDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
    ON_CBN_SELCHANGE(IDC_COMBO_BOARD_AND_MODULE_0, &CadqSignalGeneratorDlg::OnCbnSelchangeComboBoardAndModule0)
    ON_CBN_SELCHANGE(IDC_COMBO_BOARD_AND_MODULE_1, &CadqSignalGeneratorDlg::OnCbnSelchangeComboBoardAndModule1)
    ON_CBN_SELCHANGE(IDC_COMBO_BOARD_AND_MODULE_2, &CadqSignalGeneratorDlg::OnCbnSelchangeComboBoardAndModule2)
    ON_CBN_SELCHANGE(IDC_COMBO_BOARD_AND_MODULE_3, &CadqSignalGeneratorDlg::OnCbnSelchangeComboBoardAndModule3)
    ON_CBN_SELCHANGE(IDC_COMBO_BOARD_AND_MODULE_4, &CadqSignalGeneratorDlg::OnCbnSelchangeComboBoardAndModule4)
    ON_CBN_SELCHANGE(IDC_COMBO_BOARD_AND_MODULE_5, &CadqSignalGeneratorDlg::OnCbnSelchangeComboBoardAndModule5)
    ON_CBN_SELCHANGE(IDC_COMBO_BOARD_AND_MODULE_6, &CadqSignalGeneratorDlg::OnCbnSelchangeComboBoardAndModule6)
    ON_CBN_SELCHANGE(IDC_COMBO_BOARD_AND_MODULE_7, &CadqSignalGeneratorDlg::OnCbnSelchangeComboBoardAndModule7)
    ON_EN_CHANGE(IDC_EDIT_REQUIRED_FREQUENCY_0, &CadqSignalGeneratorDlg::OnEnChangeEditRequiredFrequency0)
    ON_EN_CHANGE(IDC_EDIT_REQUIRED_FREQUENCY_1, &CadqSignalGeneratorDlg::OnEnChangeEditRequiredFrequency1)
    ON_EN_CHANGE(IDC_EDIT_REQUIRED_FREQUENCY_2, &CadqSignalGeneratorDlg::OnEnChangeEditRequiredFrequency2)
    ON_EN_CHANGE(IDC_EDIT_REQUIRED_FREQUENCY_3, &CadqSignalGeneratorDlg::OnEnChangeEditRequiredFrequency3)
    ON_EN_CHANGE(IDC_EDIT_REQUIRED_FREQUENCY_4, &CadqSignalGeneratorDlg::OnEnChangeEditRequiredFrequency4)
    ON_EN_CHANGE(IDC_EDIT_REQUIRED_FREQUENCY_5, &CadqSignalGeneratorDlg::OnEnChangeEditRequiredFrequency5)
    ON_EN_CHANGE(IDC_EDIT_REQUIRED_FREQUENCY_6, &CadqSignalGeneratorDlg::OnEnChangeEditRequiredFrequency6)
    ON_EN_CHANGE(IDC_EDIT_REQUIRED_FREQUENCY_7, &CadqSignalGeneratorDlg::OnEnChangeEditRequiredFrequency7)
    ON_BN_CLICKED(IDC_CHECK_SUPERIMPOSED_SIGNAL_0, &CadqSignalGeneratorDlg::OnBnClickedCheckSuperimposedSignal0)
    ON_BN_CLICKED(IDC_CHECK_SUPERIMPOSED_SIGNAL_1, &CadqSignalGeneratorDlg::OnBnClickedCheckSuperimposedSignal1)
    ON_BN_CLICKED(IDC_CHECK_SUPERIMPOSED_SIGNAL_2, &CadqSignalGeneratorDlg::OnBnClickedCheckSuperimposedSignal2)
    ON_BN_CLICKED(IDC_CHECK_SUPERIMPOSED_SIGNAL_3, &CadqSignalGeneratorDlg::OnBnClickedCheckSuperimposedSignal3)
    ON_BN_CLICKED(IDC_CHECK_SUPERIMPOSED_SIGNAL_4, &CadqSignalGeneratorDlg::OnBnClickedCheckSuperimposedSignal4)
    ON_BN_CLICKED(IDC_CHECK_SUPERIMPOSED_SIGNAL_5, &CadqSignalGeneratorDlg::OnBnClickedCheckSuperimposedSignal5)
    ON_BN_CLICKED(IDC_CHECK_SUPERIMPOSED_SIGNAL_6, &CadqSignalGeneratorDlg::OnBnClickedCheckSuperimposedSignal6)
    ON_BN_CLICKED(IDC_CHECK_SUPERIMPOSED_SIGNAL_7, &CadqSignalGeneratorDlg::OnBnClickedCheckSuperimposedSignal7)
    ON_BN_CLICKED(IDC_BUTTON_START_STOP_0, &CadqSignalGeneratorDlg::OnBnClickedButtonStartStop0)
    ON_BN_CLICKED(IDC_BUTTON_START_STOP_1, &CadqSignalGeneratorDlg::OnBnClickedButtonStartStop1)
    ON_BN_CLICKED(IDC_BUTTON_START_STOP_2, &CadqSignalGeneratorDlg::OnBnClickedButtonStartStop2)
    ON_BN_CLICKED(IDC_BUTTON_START_STOP_3, &CadqSignalGeneratorDlg::OnBnClickedButtonStartStop3)
    ON_BN_CLICKED(IDC_BUTTON_START_STOP_4, &CadqSignalGeneratorDlg::OnBnClickedButtonStartStop4)
    ON_BN_CLICKED(IDC_BUTTON_START_STOP_5, &CadqSignalGeneratorDlg::OnBnClickedButtonStartStop5)
    ON_BN_CLICKED(IDC_BUTTON_START_STOP_6, &CadqSignalGeneratorDlg::OnBnClickedButtonStartStop6)
    ON_BN_CLICKED(IDC_BUTTON_START_STOP_7, &CadqSignalGeneratorDlg::OnBnClickedButtonStartStop7)
    ON_WM_DRAWITEM()
END_MESSAGE_MAP()


// CadqSignalGeneratorDlg message handlers

BOOL CadqSignalGeneratorDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

    unsigned int ui_adq_error = adqOpen();

    CString cs_message;

    if(ui_adq_error != ADQ_ERROR_NONE)
    {
        cs_message.Format(  _T("adqOpen returned 0x%08X\n\n")
                             _T("Program will be terminated"), 
                            ui_adq_error                    );

        AfxMessageBox(cs_message, MB_OK | MB_ICONSTOP);

        EndDialog(IDCANCEL);

        return FALSE;
    }

    unsigned int ui_number_of_boards;
    
    ui_adq_error = adqGetNumberOfBoards(ui_number_of_boards);

    if(ui_adq_error != ADQ_ERROR_NONE)
    {
        cs_message.Format(  _T("adqGetNumberOfBoards returned 0x%08X\n\n") 
                             _T("Program will be terminated"), 
                            ui_adq_error                                    );

        AfxMessageBox(cs_message, MB_OK | MB_ICONSTOP);

        EndDialog(IDCANCEL);

        return FALSE;
    }

    if(ui_number_of_boards == 0)
    {
        cs_message.Format(  _T("No ADQ Boards found\n\n") 
                             _T("Program will be terminated"), 
                            ui_adq_error                                    );

        AfxMessageBox(cs_message, MB_OK | MB_ICONSTOP);

        EndDialog(IDCANCEL);

        return FALSE;
    }

    // Count the number of AO modules

    unsigned int m_uiNumberOfModules = 0;

    for(unsigned int ui_index_board = 0; ui_index_board < ui_number_of_boards; ui_index_board++)
    {
        unsigned int ui_number_of_modules;

        ui_adq_error = adqGetNumberOfModules(ui_index_board, ui_number_of_modules);

        if(ui_adq_error != ADQ_ERROR_NONE)
        {
            cs_message.Format(  _T("Board index: %3u adqGetNumberOfModules returned 0x%08X"), 
                                ui_index_board, ui_adq_error                                );

            AfxMessageBox(cs_message, MB_OK | MB_ICONEXCLAMATION);

            continue;
        }

        for(unsigned int ui_index_module = 0; ui_index_module < ui_number_of_modules; ui_index_module++)
        {
            unsigned int ui_module_type;

            ui_adq_error = adqGetModuleType(ui_index_board, ui_index_module, ui_module_type);

            if(ui_adq_error != ADQ_ERROR_NONE)
            {
                cs_message.Format(  _T("Board index: %3u Module index: %3u adqGetModuleType returned 0x%08X"), 
                                    ui_index_board, ui_index_module, ui_adq_error                            );

                AfxMessageBox(cs_message, MB_OK | MB_ICONEXCLAMATION);

                continue;
            }

            if(ui_module_type == ADQ_MODULE_TYPE_AO)
            {
                ++m_uiNumberOfModules;
            }
        }
    }

    if(m_uiNumberOfModules == 0)
    {
        cs_message.Format(  _T("No AO modules found") 
                             _T("Program will be terminated"), 
                            ui_adq_error                    );

        AfxMessageBox(cs_message, MB_OK | MB_ICONSTOP);

        EndDialog(IDCANCEL);

        return FALSE;
    }

    unsigned int ui_max_number_of_ao_modules = m_uiNumberOfModules;

    m_parrAOModules = new SAOModule[ui_max_number_of_ao_modules];

    m_uiNumberOfModules = 0;

    for(unsigned int ui_index_board = 0; ui_index_board < ui_number_of_boards; ui_index_board++)
    {
        unsigned int ui_number_of_modules;

        ui_adq_error = adqGetNumberOfModules(ui_index_board, ui_number_of_modules);

        if(ui_adq_error != ADQ_ERROR_NONE)
        {
            cs_message.Format(  _T("Board index: %3u adqGetNumberOfModules returned 0x%08X"), 
                                ui_index_board, ui_adq_error                                );

            AfxMessageBox(cs_message, MB_OK | MB_ICONEXCLAMATION);

            continue;
        }

        for(unsigned int ui_index_module = 0; ui_index_module < ui_number_of_modules; ui_index_module++)
        {
            unsigned int ui_module_type;

            ui_adq_error = adqGetModuleType(ui_index_board, ui_index_module, ui_module_type);

            if(ui_adq_error != ADQ_ERROR_NONE)
            {
                cs_message.Format(  _T("Board index: %3u Module index: %3u adqGetModuleType returned 0x%08X"), 
                                    ui_index_board, ui_index_module, ui_adq_error                            );

                AfxMessageBox(cs_message, MB_OK | MB_ICONEXCLAMATION);

                continue;
            }

            SADQGeneralModuleInfo s_adq_general_module_info;

            s_adq_general_module_info.m_uiSize = sizeof(SADQGeneralModuleInfo);

            s_adq_general_module_info.m_uiID = SADQGeneralModuleInfo_ID;

            if(ui_module_type == ADQ_MODULE_TYPE_AO)
            {
                SADQBoardInfo s_adq_board_info;

                s_adq_board_info.m_uiSize = sizeof(SADQBoardInfo);

                s_adq_board_info.m_uiID = SADQBoardInfo_ID;

                ui_adq_error = adqGetBoardInfo(ui_index_board, s_adq_board_info);

                if(ui_adq_error != ADQ_ERROR_NONE)
                {
                    cs_message.Format(  _T("Board index: %3u adqGetBoardInfo returned 0x%08X"), 
                                        ui_index_board, ui_adq_error                            );

                    AfxMessageBox(cs_message, MB_OK | MB_ICONEXCLAMATION);

                    continue;
                }

                SADQAOModuleInfo s_adq_ao_module_info;

                s_adq_ao_module_info.m_uiSize = sizeof(SADQAOModuleInfo);

                s_adq_ao_module_info.m_uiID = SADQAOModuleInfo_ID;

                unsigned int ui_info_size;

                ui_adq_error = adqGetModuleInfo(ui_index_board, ui_index_module, s_adq_general_module_info, sizeof(SADQAOModuleInfo), (unsigned char*)&s_adq_ao_module_info, ui_info_size);

                if(ui_adq_error != ADQ_ERROR_NONE)
                {
                    cs_message.Format(  _T("Board index: %3u Module index: %3u adqGetModuleInfo returned 0x%08X"), 
                                        ui_index_board, ui_index_module, ui_adq_error                            );

                    AfxMessageBox(cs_message, MB_OK | MB_ICONEXCLAMATION);

                    continue;
                }

                m_parrAOModules[m_uiNumberOfModules].m_uiBoardIndex = ui_index_board;

                wcscpy_s( &m_parrAOModules[m_uiNumberOfModules].m_wszBoardName[0], 64, &s_adq_board_info.m_wszBoardName[0] );

                m_parrAOModules[m_uiNumberOfModules].m_uiModuleIndex = ui_index_module;

                m_parrAOModules[m_uiNumberOfModules].m_uiNumberOfRanges = s_adq_ao_module_info.m_uiNumberOfRanges;

                memcpy( &m_parrAOModules[m_uiNumberOfModules].m_arrRanges[0],  &s_adq_ao_module_info.m_arrRanges[0], m_parrAOModules[m_uiNumberOfModules].m_uiNumberOfRanges * sizeof(SADQAORange) );

                ++m_uiNumberOfModules;
            }
        }
    }

    unsigned int ui_index_ouput_signal = 0;

    for( ; (ui_index_ouput_signal < m_uiNumberOfModules)&&(ui_index_ouput_signal < 8); ui_index_ouput_signal++)
    {
        CComboBox* p_combo_box = (CComboBox*)GetDlgItem(IDC_COMBO_BOARD_AND_MODULE_0 + ui_index_ouput_signal);

        for(unsigned int ui_index_ao_module = 0; ui_index_ao_module < m_uiNumberOfModules; ui_index_ao_module++)
        {
            CString cs_combo;

            cs_combo.Format( _T("Board: %2u - Module: %2u"), m_parrAOModules[ui_index_ao_module].m_uiBoardIndex, m_parrAOModules[ui_index_ao_module].m_uiModuleIndex);
            
            p_combo_box-> AddString(cs_combo);
        }

        p_combo_box->SetCurSel( (int)ui_index_ouput_signal );

        SetDlgItemText( IDC_EDIT_REQUIRED_FREQUENCY_0 + ui_index_ouput_signal, _T("100.0") );

        OnEnChangeEditRequiredFrequency(ui_index_ouput_signal);

        CheckDlgButton(IDC_CHECK_SUPERIMPOSED_SIGNAL_0 + ui_index_ouput_signal, BST_UNCHECKED);

        OnBnClickedCheckSuperimposedSignal(ui_index_ouput_signal);

        unsigned int ui_number_of_signal_types = sizeof(m_arrSignalTypes) / sizeof( m_arrSignalTypes[0] );
 
        p_combo_box = (CComboBox*)GetDlgItem(IDC_COMBO_MAIN_SIGNAL_TYPE_0 + ui_index_ouput_signal);

        for(unsigned int ui_signal_type = 0; ui_signal_type < ui_number_of_signal_types; ui_signal_type++)
        {
            p_combo_box-> AddString(m_arrSignalTypes[ui_signal_type].m_tzSignalName);
        }

        p_combo_box->SetCurSel( (int)(ui_index_ouput_signal % ui_number_of_signal_types) );
 
        p_combo_box = (CComboBox*)GetDlgItem(IDC_COMBO_SUPERIMPOSED_SIGNAL_TYPE_0 + ui_index_ouput_signal);

        for(unsigned int ui_signal_type = 0; ui_signal_type < ui_number_of_signal_types; ui_signal_type++)
        {
            p_combo_box-> AddString(m_arrSignalTypes[ui_signal_type].m_tzSignalName);
        }

        p_combo_box->SetCurSel( (int)(ui_index_ouput_signal % ui_number_of_signal_types) );

        SetDlgItemText(IDC_EDIT_BEGIN_MAIN_SIGNAL_FREQUENCY_0 + ui_index_ouput_signal, _T("1.0") );

        SetDlgItemText(IDC_EDIT_BEGIN_SUPERIMPOSED_FREQUENCY_0 + ui_index_ouput_signal, _T("10.0") );

        double d_range_min =  m_parrAOModules[ui_index_ouput_signal].m_arrRanges[0].m_dPhysicalMin;  // Only one range!!

        double d_range_max =  m_parrAOModules[ui_index_ouput_signal].m_arrRanges[0].m_dPhysicalMax;  // Only one range!!

        double d_range_size = d_range_max - d_range_min;

        double d_range_mid = (d_range_max + d_range_min) / 2.0;

        CString cs_value;

        cs_value.Format( _T("%10.3f"), d_range_min + d_range_size / 10.0) ;

        SetDlgItemText(IDC_EDIT_BEGIN_MAIN_MINIMUM_0 + ui_index_ouput_signal, cs_value );

        cs_value.Format( _T("%10.3f"), -d_range_size / 10.0 );

        SetDlgItemText(IDC_EDIT_BEGIN_SUPERIMPOSED_MINIMUM_0 + ui_index_ouput_signal, cs_value );

        cs_value.Format( _T("%10.3f"), d_range_mid );

        SetDlgItemText(IDC_EDIT_BEGIN_MAIN_MAXIMUM_0 + ui_index_ouput_signal, cs_value );

        cs_value.Format( _T("%10.3f"), +d_range_size / 10.0 );

        SetDlgItemText(IDC_EDIT_BEGIN_SUPERIMPOSED_MAXIMUM_0 + ui_index_ouput_signal, cs_value );

        SetDlgItemText(IDC_EDIT_END_MAIN_SIGNAL_FREQUENCY_0 + ui_index_ouput_signal, _T("4.0") );

        SetDlgItemText(IDC_EDIT_END_SUPERIMPOSED_FREQUENCY_0 + ui_index_ouput_signal, _T("10.0") );

        cs_value.Format( _T("%10.3f"), d_range_mid) ;

        SetDlgItemText(IDC_EDIT_END_MAIN_MINIMUM_0 + ui_index_ouput_signal, cs_value );

        cs_value.Format( _T("%10.3f"), -d_range_size / 10.0 );

        SetDlgItemText(IDC_EDIT_END_SUPERIMPOSED_MINIMUM_0 + ui_index_ouput_signal, cs_value );

        cs_value.Format( _T("%10.3f"), d_range_max - d_range_size / 10.0) ;

        SetDlgItemText(IDC_EDIT_END_MAIN_MAXIMUM_0 + ui_index_ouput_signal, cs_value );

        cs_value.Format( _T("%10.3f"), +d_range_size / 10.0 );

        SetDlgItemText(IDC_EDIT_END_SUPERIMPOSED_MAXIMUM_0 + ui_index_ouput_signal, cs_value );

        SetDlgItemText(IDC_SIGNAL_LENGTH_0 + ui_index_ouput_signal, _T("10")  );

        SetDlgItemText(IDC_SIGNAL_REPEATS_0 + ui_index_ouput_signal, _T("4")  );
    }

    for(; ui_index_ouput_signal < 8; ui_index_ouput_signal++)
    {
        GetDlgItem(IDC_STATIC_NUMBER_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_COMBO_BOARD_AND_MODULE_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_EDIT_REQUIRED_FREQUENCY_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_STATIC_REQUIRED_FREQUENCY_HZ_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_STATIC_ACTUAL_FREQUEMCY_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_STATIC_MAIN_SIGNAL_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_CHECK_SUPERIMPOSED_SIGNAL_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_COMBO_MAIN_SIGNAL_TYPE_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_COMBO_SUPERIMPOSED_SIGNAL_TYPE_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_EDIT_BEGIN_MAIN_SIGNAL_FREQUENCY_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_EDIT_BEGIN_SUPERIMPOSED_FREQUENCY_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_STATIC_BEGIN_MAIN_FREQUENCY_HZ_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_STATIC_BEGIN_SUPERIMPOSED_FREQUENCY_HZ_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_EDIT_BEGIN_MAIN_MINIMUM_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_EDIT_BEGIN_SUPERIMPOSED_MINIMUM_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_STATIC_BEGIN_MAIN_MINIMUM_UNIT_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_STATIC_BEGIN_SUPERIMPOSED_MINIMUM_UNIT_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_EDIT_BEGIN_MAIN_MAXIMUM_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_EDIT_BEGIN_SUPERIMPOSED_MAXIMUM_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_STATIC_BEGIN_MAIN_MAXIMUM_UNIT_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_STATIC_BEGIN_SUPERIMPOSED_MAXIMUM_UNIT_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_EDIT_END_MAIN_SIGNAL_FREQUENCY_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_EDIT_END_SUPERIMPOSED_FREQUENCY_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_STATIC_END_MAIN_FREQUENCY_HZ_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_STATIC_END_SUPERIMPOSED_FREQUENCY_HZ_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_EDIT_END_MAIN_MINIMUM_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_EDIT_END_SUPERIMPOSED_MINIMUM_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_STATIC_END_MAIN_MINIMUM_UNIT_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_STATIC_END_SUPERIMPOSED_MINIMUM_UNIT_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_EDIT_END_MAIN_MAXIMUM_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_EDIT_END_SUPERIMPOSED_MAXIMUM_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_STATIC_END_MAIN_MAXIMUM_UNIT_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_STATIC_END_SUPERIMPOSED_MAXIMUM_UNIT_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_SIGNAL_LENGTH_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_STATIC_SIGNAL_LENGTH_UNIT_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_SIGNAL_REPEATS_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
        
        GetDlgItem(IDC_BUTTON_START_STOP_0 + ui_index_ouput_signal)->ShowWindow(SW_HIDE);
    }

    for(unsigned int ui_index_output_signal = 0; ui_index_output_signal < 8; ui_index_output_signal++)
    {
        m_arrOutputSignals[ui_index_output_signal].m_pSignalGeneratorDlg = this;

        m_arrOutputSignals[ui_index_output_signal].m_uiSignalIndex = ui_index_output_signal;
 
        m_arrOutputSignals[ui_index_output_signal].m_bOutputRunning = 0;
    }

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CadqSignalGeneratorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CadqSignalGeneratorDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CadqSignalGeneratorDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CadqSignalGeneratorDlg :: OnCbnSelchangeComboBoardAndModule(unsigned int uiOutputSignalIndex)
{
    OnEnChangeEditRequiredFrequency(uiOutputSignalIndex);
}

void CadqSignalGeneratorDlg :: OnEnChangeEditRequiredFrequency(unsigned int uiOutputSignalIndex)
{
    TCHAR tsz_sampling_rate[64];

    GetDlgItemText(IDC_EDIT_REQUIRED_FREQUENCY_0 + uiOutputSignalIndex, &tsz_sampling_rate[0], 64);

    double d_required_sampling_rate;
    
    double d_achieved_frequency = 0.0;

    if( _stscanf(&tsz_sampling_rate[0], _T("%lf"), &d_required_sampling_rate) == 1 )
    {
        CComboBox* p_combo = (CComboBox*)GetDlgItem(IDC_COMBO_BOARD_AND_MODULE_0 + uiOutputSignalIndex);

        unsigned int ui_ao_module_index = (unsigned int)p_combo->GetCurSel();
        
        adqSetFrequency(m_parrAOModules[ui_ao_module_index].m_uiBoardIndex, m_parrAOModules[ui_ao_module_index].m_uiModuleIndex, d_required_sampling_rate, d_achieved_frequency);
        
        m_arrOutputSignals[uiOutputSignalIndex].m_dActualFrequency = d_achieved_frequency;

        _stprintf( &tsz_sampling_rate[0], _T("%10.3f Hz"), d_achieved_frequency);
        
        SetDlgItemText( IDC_STATIC_ACTUAL_FREQUEMCY_0 + uiOutputSignalIndex, &tsz_sampling_rate[0] );
    }
    else
    { 
        SetDlgItemText( IDC_STATIC_ACTUAL_FREQUEMCY_0 + uiOutputSignalIndex, _T("?????? Hz") );
    }
}

void CadqSignalGeneratorDlg :: OnBnClickedCheckSuperimposedSignal(unsigned int uiOutputSignalIndex)
{
    BOOL b_enable = (IsDlgButtonChecked(IDC_CHECK_SUPERIMPOSED_SIGNAL_0 + uiOutputSignalIndex) == 0) ? FALSE : TRUE;

    GetDlgItem(IDC_COMBO_SUPERIMPOSED_SIGNAL_TYPE_0 + uiOutputSignalIndex)->EnableWindow(b_enable);
        
    GetDlgItem(IDC_EDIT_BEGIN_SUPERIMPOSED_FREQUENCY_0 + uiOutputSignalIndex)->EnableWindow(b_enable);
        
    GetDlgItem(IDC_STATIC_BEGIN_SUPERIMPOSED_FREQUENCY_HZ_0 + uiOutputSignalIndex)->EnableWindow(b_enable);
        
    GetDlgItem(IDC_EDIT_BEGIN_SUPERIMPOSED_MINIMUM_0 + uiOutputSignalIndex)->EnableWindow(b_enable);
        
    GetDlgItem(IDC_STATIC_BEGIN_SUPERIMPOSED_MINIMUM_UNIT_0 + uiOutputSignalIndex)->EnableWindow(b_enable);
        
    GetDlgItem(IDC_EDIT_BEGIN_SUPERIMPOSED_MAXIMUM_0 + uiOutputSignalIndex)->EnableWindow(b_enable);
        
    GetDlgItem(IDC_STATIC_BEGIN_SUPERIMPOSED_MAXIMUM_UNIT_0 + uiOutputSignalIndex)->EnableWindow(b_enable);
        
    GetDlgItem(IDC_EDIT_END_SUPERIMPOSED_FREQUENCY_0 + uiOutputSignalIndex)->EnableWindow(b_enable);
        
    GetDlgItem(IDC_STATIC_END_SUPERIMPOSED_FREQUENCY_HZ_0 + uiOutputSignalIndex)->EnableWindow(b_enable);
        
    GetDlgItem(IDC_EDIT_END_SUPERIMPOSED_MINIMUM_0 + uiOutputSignalIndex)->EnableWindow(b_enable);
        
    GetDlgItem(IDC_STATIC_END_SUPERIMPOSED_MINIMUM_UNIT_0 + uiOutputSignalIndex)->EnableWindow(b_enable);
        
    GetDlgItem(IDC_EDIT_END_SUPERIMPOSED_MAXIMUM_0 + uiOutputSignalIndex)->EnableWindow(b_enable);
        
    GetDlgItem(IDC_STATIC_END_SUPERIMPOSED_MAXIMUM_UNIT_0 + uiOutputSignalIndex)->EnableWindow(b_enable);
}

void CadqSignalGeneratorDlg :: OnBnClickedButtonStartStop(unsigned int uiOutputSignalIndex)
{
    SOutputSignal* p_output_signal = &m_arrOutputSignals[uiOutputSignalIndex];

    if(p_output_signal->m_bOutputRunning == 0)
    {
        CComboBox* p_combo = (CComboBox*)GetDlgItem(IDC_COMBO_BOARD_AND_MODULE_0 + uiOutputSignalIndex);

        unsigned int ui_ao_module_index = (unsigned int)p_combo->GetCurSel();

        p_output_signal->m_uiBoardIndex = m_parrAOModules[ui_ao_module_index].m_uiBoardIndex;

        p_output_signal->m_uiModuleIndex = m_parrAOModules[ui_ao_module_index].m_uiModuleIndex;

        p_output_signal->m_sADQAORange = m_parrAOModules[ui_ao_module_index].m_arrRanges[0];
        
        unsigned int ui_thread_id;
        
        m_arrOutputSignals[uiOutputSignalIndex].m_hThread = (HANDLE)_beginthreadex(NULL,                // Pointer to the security attributes
                                                                                   0,                   // Stack size - Use default
                                                                                   OutputThread,        // Thread function,
                                                                                   p_output_signal,     // Argument passed to thread
                                                                                   0,                   // Flags - Use defaults
                                                                                   &ui_thread_id    );  // Thread ID returned here 
    }
    else
    {
        adqStop(p_output_signal->m_uiBoardIndex, p_output_signal->m_uiModuleIndex);

        WaitForSingleObject(p_output_signal->m_hThread, 1000);  // Wait upto 1 second for the thread to terminate
    }
}

double SignalValue(unsigned int uiSignalType, double dTime, double dSignalFrequency, double dSignalMinimum, double dSignalMaximum)
{
    double d_value = 0.0;

    double d_cycle_time = dTime * dSignalFrequency - floor(dTime * dSignalFrequency);

    switch(uiSignalType)
    {
    case SIGNAL_TYPE_SINUS:

        d_value = (dSignalMaximum + dSignalMinimum) / 2.0 + (dSignalMaximum - dSignalMinimum) / 2.0 * sin(2.0 * M_PI * d_cycle_time);

        break;

    case SIGNAL_TYPE_TRIANGLE:

        if(d_cycle_time <= 0.5)
        {
            d_value = dSignalMinimum + 2 * (dSignalMaximum - dSignalMinimum) * d_cycle_time;
        }
        else
        {
            d_value = dSignalMaximum - 2 * (dSignalMaximum - dSignalMinimum) * (d_cycle_time - 0.5);
        }

        break;

    case SIGNAL_TYPE_SAW_TOOTH_LEFT:
        
        d_value = dSignalMinimum + (dSignalMaximum - dSignalMinimum) * d_cycle_time;

        break;

    case SIGNAL_TYPE_SAW_TOOTH_RIGHT:

        d_value = dSignalMaximum - (dSignalMaximum - dSignalMinimum) * d_cycle_time;
        
        break;

    case SIGNAL_TYPE_RECTANGLE:

        if(d_cycle_time <= 0.5)
        {
            d_value = dSignalMinimum;
        }
        else
        {
            d_value = dSignalMaximum;
        }

        break;
    }

    return d_value;
}

unsigned int __stdcall CadqSignalGeneratorDlg :: OutputThread(void* pvArg)
{
    CString cs_message;

    SOutputSignal* p_output_signal = (SOutputSignal*)pvArg;

    TCHAR tsz_control_text[64];

    p_output_signal->m_pSignalGeneratorDlg->GetDlgItemText(IDC_SIGNAL_LENGTH_0 + p_output_signal->m_uiSignalIndex, &tsz_control_text[0], 64);

    double d_signal_length_seconds; 

    if( _stscanf(&tsz_control_text[0], _T("%lf"), &d_signal_length_seconds) != 1 )
    {
    }

    unsigned int ui_number_of_values = (unsigned int)( d_signal_length_seconds * p_output_signal->m_dActualFrequency );

    unsigned int* p_ui_data = new unsigned int[ui_number_of_values];

    CComboBox* p_combo = (CComboBox*)p_output_signal->m_pSignalGeneratorDlg->GetDlgItem(IDC_COMBO_MAIN_SIGNAL_TYPE_0 + p_output_signal->m_uiSignalIndex);

    unsigned int ui_main_signal_type = (unsigned int)p_combo->GetCurSel();

    p_output_signal->m_pSignalGeneratorDlg->GetDlgItemText(IDC_EDIT_BEGIN_MAIN_SIGNAL_FREQUENCY_0 + p_output_signal->m_uiSignalIndex, &tsz_control_text[0], 64);

    double d_main_signal_frequency_from;

    if( _stscanf(&tsz_control_text[0], _T("%lf"), &d_main_signal_frequency_from) != 1 )
    {
    }

    p_output_signal->m_pSignalGeneratorDlg->GetDlgItemText(IDC_EDIT_END_MAIN_SIGNAL_FREQUENCY_0 + p_output_signal->m_uiSignalIndex, &tsz_control_text[0], 64);

    double d_main_signal_frequency_to;

    if( _stscanf(&tsz_control_text[0], _T("%lf"), &d_main_signal_frequency_to) != 1 )
    {
    }

    p_output_signal->m_pSignalGeneratorDlg->GetDlgItemText(IDC_EDIT_BEGIN_MAIN_MINIMUM_0 + p_output_signal->m_uiSignalIndex, &tsz_control_text[0], 64);

    double d_main_signal_physical_min_from;

    if( _stscanf(&tsz_control_text[0], _T("%lf"), &d_main_signal_physical_min_from) != 1 )
    {
    }

    p_output_signal->m_pSignalGeneratorDlg->GetDlgItemText(IDC_EDIT_END_MAIN_MINIMUM_0 + p_output_signal->m_uiSignalIndex, &tsz_control_text[0], 64);

    double d_main_signal_physical_min_to;

    if( _stscanf(&tsz_control_text[0], _T("%lf"), &d_main_signal_physical_min_to) != 1 )
    {
    }

    p_output_signal->m_pSignalGeneratorDlg->GetDlgItemText(IDC_EDIT_BEGIN_MAIN_MAXIMUM_0 + p_output_signal->m_uiSignalIndex, &tsz_control_text[0], 64);

    double d_main_signal_physical_max_from;

    if( _stscanf(&tsz_control_text[0], _T("%lf"), &d_main_signal_physical_max_from) != 1 )
    {
    }

    p_output_signal->m_pSignalGeneratorDlg->GetDlgItemText(IDC_EDIT_END_MAIN_MAXIMUM_0 + p_output_signal->m_uiSignalIndex, &tsz_control_text[0], 64);

    double d_main_signal_physical_max_to;

    if( _stscanf(&tsz_control_text[0], _T("%lf"), &d_main_signal_physical_max_to) != 1 )
    {
    }

    unsigned int ui_superimposed_signal_type;

    double d_superimposed_signal_frequency_from;

    double d_superimposed_signal_frequency_to;

    double d_superimposed_signal_physical_min_from;

    double d_superimposed_signal_physical_min_to;

    double d_superimposed_signal_physical_max_from;

    double d_superimposed_signal_physical_max_to;

    int b_use_superimposed_signal = p_output_signal->m_pSignalGeneratorDlg->IsDlgButtonChecked(IDC_CHECK_SUPERIMPOSED_SIGNAL_0 + p_output_signal->m_uiSignalIndex);

    if(b_use_superimposed_signal != 0)
    {
        p_combo = (CComboBox*)p_output_signal->m_pSignalGeneratorDlg->GetDlgItem(IDC_COMBO_SUPERIMPOSED_SIGNAL_TYPE_0 + p_output_signal->m_uiSignalIndex);

        ui_superimposed_signal_type = (unsigned int)p_combo->GetCurSel();

        p_output_signal->m_pSignalGeneratorDlg->GetDlgItemText(IDC_EDIT_BEGIN_SUPERIMPOSED_FREQUENCY_0 + p_output_signal->m_uiSignalIndex, &tsz_control_text[0], 64);

        if( _stscanf(&tsz_control_text[0], _T("%lf"), &d_superimposed_signal_frequency_from) != 1 )
        {
        }

        p_output_signal->m_pSignalGeneratorDlg->GetDlgItemText(IDC_EDIT_END_SUPERIMPOSED_FREQUENCY_0 + p_output_signal->m_uiSignalIndex, &tsz_control_text[0], 64);

        if( _stscanf(&tsz_control_text[0], _T("%lf"), &d_superimposed_signal_frequency_to) != 1 )
        {
        }

        p_output_signal->m_pSignalGeneratorDlg->GetDlgItemText(IDC_EDIT_BEGIN_SUPERIMPOSED_MINIMUM_0 + p_output_signal->m_uiSignalIndex, &tsz_control_text[0], 64);

        if( _stscanf(&tsz_control_text[0], _T("%lf"), &d_superimposed_signal_physical_min_from) != 1 )
        {
        }

        p_output_signal->m_pSignalGeneratorDlg->GetDlgItemText(IDC_EDIT_END_SUPERIMPOSED_MINIMUM_0 + p_output_signal->m_uiSignalIndex, &tsz_control_text[0], 64);

        if( _stscanf(&tsz_control_text[0], _T("%lf"), &d_superimposed_signal_physical_min_to) != 1 )
        {
        }

        p_output_signal->m_pSignalGeneratorDlg->GetDlgItemText(IDC_EDIT_BEGIN_SUPERIMPOSED_MAXIMUM_0 + p_output_signal->m_uiSignalIndex, &tsz_control_text[0], 64);

        if( _stscanf(&tsz_control_text[0], _T("%lf"), &d_superimposed_signal_physical_max_from) != 1 )
        {
        }

        p_output_signal->m_pSignalGeneratorDlg->GetDlgItemText(IDC_EDIT_END_SUPERIMPOSED_MAXIMUM_0 + p_output_signal->m_uiSignalIndex, &tsz_control_text[0], 64);

        if( _stscanf(&tsz_control_text[0], _T("%lf"), &d_superimposed_signal_physical_max_to) != 1 )
        {
        }
    }

    unsigned int ui_buffer_repeats = p_output_signal->m_pSignalGeneratorDlg->GetDlgItemInt(IDC_SIGNAL_REPEATS_0 + p_output_signal->m_uiSignalIndex);

    double d_factor = (double)(p_output_signal->m_sADQAORange.m_uiDigitalMax - p_output_signal->m_sADQAORange.m_uiDigitalMin) / 
                                                        (p_output_signal->m_sADQAORange.m_dPhysicalMax - p_output_signal->m_sADQAORange.m_dPhysicalMin);
        
    double d_constant = (double)p_output_signal->m_sADQAORange.m_uiDigitalMin - p_output_signal->m_sADQAORange.m_dPhysicalMin * d_factor; 

    double d_signal_min = +DBL_MAX;

    double d_signal_max = -DBL_MAX;

    for(unsigned int ui_index_data = 0; ui_index_data < ui_number_of_values; ui_index_data++)
    {
        double d_time = (double)ui_index_data / p_output_signal->m_dActualFrequency;

        double d_signal_frequency = d_main_signal_frequency_from + d_time * (d_main_signal_frequency_to - d_main_signal_frequency_from) / d_signal_length_seconds; 

        double d_signal_physical_min = d_main_signal_physical_min_from + d_time * (d_main_signal_physical_min_to - d_main_signal_physical_min_from) / d_signal_length_seconds; 

        double d_signal_physical_max = d_main_signal_physical_max_from + d_time * (d_main_signal_physical_max_to - d_main_signal_physical_max_from) / d_signal_length_seconds; 

        double d_value = SignalValue(ui_main_signal_type, d_time, d_signal_frequency, d_signal_physical_min, d_signal_physical_max);

        if(b_use_superimposed_signal != 0)
        {
            d_signal_frequency = d_superimposed_signal_frequency_from + d_time * (d_superimposed_signal_frequency_to - d_superimposed_signal_frequency_from) / d_signal_length_seconds; 

            d_signal_physical_min = d_superimposed_signal_physical_min_from + d_time * (d_superimposed_signal_physical_min_to - d_superimposed_signal_physical_min_from) / d_signal_length_seconds; 

            d_signal_physical_max = d_superimposed_signal_physical_max_from + d_time * (d_superimposed_signal_physical_max_to - d_superimposed_signal_physical_max_from) / d_signal_length_seconds; 

            d_value+= SignalValue(ui_superimposed_signal_type, d_time, d_signal_frequency, d_signal_physical_min, d_signal_physical_max);
        }

        if(d_signal_min > d_value)
        {
            d_signal_min = d_value;
        }

        if(d_signal_max < d_value)
        {
            d_signal_max = d_value;
        }

        if(d_value <= p_output_signal->m_sADQAORange.m_dPhysicalMin)
        {
            p_ui_data[ui_index_data] = p_output_signal->m_sADQAORange.m_uiDigitalMin;
        }
        else if(d_value >= p_output_signal->m_sADQAORange.m_dPhysicalMax)
        {
            p_ui_data[ui_index_data] = p_output_signal->m_sADQAORange.m_uiDigitalMax;
        }
        else
        {
            p_ui_data[ui_index_data] = (unsigned int)(d_value * d_factor + d_constant);
        }
    }

    if( (d_signal_min < p_output_signal->m_sADQAORange.m_dPhysicalMin)||(d_signal_max > p_output_signal->m_sADQAORange.m_dPhysicalMax) )
    {
        cs_message.Format(  _T("A part of the  signal range, %10.3f V - %10.3f V lies outside the module's output range,  %10.3f V - %10.3f V\n\n")
                            _T("Values out of range will be truncated to minumum or maximum physical value which can be output")
                            _T("Do you wish to continue?"),
                            d_signal_min,
                            d_signal_max,
                            p_output_signal->m_sADQAORange.m_dPhysicalMin,
                            p_output_signal->m_sADQAORange.m_dPhysicalMax                                                                           );

        if( AfxMessageBox(cs_message, MB_ICONQUESTION | MB_YESNO) == IDNO)
        {
            return 1;
        }
    }

    unsigned int ui_number_of_values_written;

    p_output_signal->m_bOutputRunning = 1;

    p_output_signal->m_pSignalGeneratorDlg->GetDlgItem(IDC_BUTTON_START_STOP_0 + p_output_signal->m_uiSignalIndex)->Invalidate();

    unsigned int ui_adq_error = adqWriteBuffer(p_output_signal->m_uiBoardIndex, p_output_signal->m_uiModuleIndex, ui_number_of_values, p_ui_data, ui_buffer_repeats, ui_number_of_values_written);

    if(ui_adq_error != ADQ_ERROR_NONE)
    {
    }

    delete p_ui_data;

    for( ; ; )
    {
        unsigned int ui_number_of_values_acceptable = 0;

        bool b_running;

        ui_adq_error = adqWriteContinuousStatus(p_output_signal->m_uiBoardIndex, p_output_signal->m_uiModuleIndex, false, ui_number_of_values_acceptable, b_running); 

        if(ui_adq_error != ADQ_ERROR_NONE)
        {
        }

        if(!b_running)
        {
            break;
        }

        Sleep(100);
    }

    p_output_signal->m_bOutputRunning = 0;

    p_output_signal->m_pSignalGeneratorDlg->GetDlgItem(IDC_BUTTON_START_STOP_0 + p_output_signal->m_uiSignalIndex)->Invalidate();

    return 0;
}


void CadqSignalGeneratorDlg::OnCbnSelchangeComboBoardAndModule0()
{
    // TODO: Add your control notification handler code here

    OnCbnSelchangeComboBoardAndModule(0);
}


void CadqSignalGeneratorDlg::OnCbnSelchangeComboBoardAndModule1()
{
    // TODO: Add your control notification handler code here

    OnCbnSelchangeComboBoardAndModule(1);
}


void CadqSignalGeneratorDlg::OnCbnSelchangeComboBoardAndModule2()
{
    // TODO: Add your control notification handler code here

    OnCbnSelchangeComboBoardAndModule(2);
}


void CadqSignalGeneratorDlg::OnCbnSelchangeComboBoardAndModule3()
{
    // TODO: Add your control notification handler code here

    OnCbnSelchangeComboBoardAndModule(3);
}


void CadqSignalGeneratorDlg::OnCbnSelchangeComboBoardAndModule4()
{
    // TODO: Add your control notification handler code here

    OnCbnSelchangeComboBoardAndModule(4);
}


void CadqSignalGeneratorDlg::OnCbnSelchangeComboBoardAndModule5()
{
    // TODO: Add your control notification handler code here

    OnCbnSelchangeComboBoardAndModule(5);
}


void CadqSignalGeneratorDlg::OnCbnSelchangeComboBoardAndModule6()
{
    // TODO: Add your control notification handler code here

    OnCbnSelchangeComboBoardAndModule(6);
}


void CadqSignalGeneratorDlg::OnCbnSelchangeComboBoardAndModule7()
{
    // TODO: Add your control notification handler code here

    OnCbnSelchangeComboBoardAndModule(7);
}


void CadqSignalGeneratorDlg::OnEnChangeEditRequiredFrequency0()
{
    // TODO:  If this is a RICHEDIT control, the control will not
    // send this notification unless you override the CDialogEx::OnInitDialog()
    // function and call CRichEditCtrl().SetEventMask()
    // with the ENM_CHANGE flag ORed into the mask.

    // TODO:  Add your control notification handler code here

    OnEnChangeEditRequiredFrequency(0);
}


void CadqSignalGeneratorDlg::OnEnChangeEditRequiredFrequency1()
{
    // TODO:  If this is a RICHEDIT control, the control will not
    // send this notification unless you override the CDialogEx::OnInitDialog()
    // function and call CRichEditCtrl().SetEventMask()
    // with the ENM_CHANGE flag ORed into the mask.

    // TODO:  Add your control notification handler code here

    OnEnChangeEditRequiredFrequency(1);
}


void CadqSignalGeneratorDlg::OnEnChangeEditRequiredFrequency2()
{
    // TODO:  If this is a RICHEDIT control, the control will not
    // send this notification unless you override the CDialogEx::OnInitDialog()
    // function and call CRichEditCtrl().SetEventMask()
    // with the ENM_CHANGE flag ORed into the mask.

    // TODO:  Add your control notification handler code here

    OnEnChangeEditRequiredFrequency(2);
}


void CadqSignalGeneratorDlg::OnEnChangeEditRequiredFrequency3()
{
    // TODO:  If this is a RICHEDIT control, the control will not
    // send this notification unless you override the CDialogEx::OnInitDialog()
    // function and call CRichEditCtrl().SetEventMask()
    // with the ENM_CHANGE flag ORed into the mask.

    // TODO:  Add your control notification handler code here

    OnEnChangeEditRequiredFrequency(3);
}


void CadqSignalGeneratorDlg::OnEnChangeEditRequiredFrequency4()
{
    // TODO:  If this is a RICHEDIT control, the control will not
    // send this notification unless you override the CDialogEx::OnInitDialog()
    // function and call CRichEditCtrl().SetEventMask()
    // with the ENM_CHANGE flag ORed into the mask.

    // TODO:  Add your control notification handler code here

    OnEnChangeEditRequiredFrequency(4);
}


void CadqSignalGeneratorDlg::OnEnChangeEditRequiredFrequency5()
{
    // TODO:  If this is a RICHEDIT control, the control will not
    // send this notification unless you override the CDialogEx::OnInitDialog()
    // function and call CRichEditCtrl().SetEventMask()
    // with the ENM_CHANGE flag ORed into the mask.

    // TODO:  Add your control notification handler code here

    OnEnChangeEditRequiredFrequency(5);
}


void CadqSignalGeneratorDlg::OnEnChangeEditRequiredFrequency6()
{
    // TODO:  If this is a RICHEDIT control, the control will not
    // send this notification unless you override the CDialogEx::OnInitDialog()
    // function and call CRichEditCtrl().SetEventMask()
    // with the ENM_CHANGE flag ORed into the mask.

    // TODO:  Add your control notification handler code here

    OnEnChangeEditRequiredFrequency(6);
}


void CadqSignalGeneratorDlg::OnEnChangeEditRequiredFrequency7()
{
    // TODO:  If this is a RICHEDIT control, the control will not
    // send this notification unless you override the CDialogEx::OnInitDialog()
    // function and call CRichEditCtrl().SetEventMask()
    // with the ENM_CHANGE flag ORed into the mask.

    // TODO:  Add your control notification handler code here

    OnEnChangeEditRequiredFrequency(7);
}


void CadqSignalGeneratorDlg::OnBnClickedCheckSuperimposedSignal0()
{
    // TODO: Add your control notification handler code here

    OnBnClickedCheckSuperimposedSignal(0);
}


void CadqSignalGeneratorDlg::OnBnClickedCheckSuperimposedSignal1()
{
    // TODO: Add your control notification handler code here

    OnBnClickedCheckSuperimposedSignal(1);
}


void CadqSignalGeneratorDlg::OnBnClickedCheckSuperimposedSignal2()
{
    // TODO: Add your control notification handler code here

    OnBnClickedCheckSuperimposedSignal(2);
}


void CadqSignalGeneratorDlg::OnBnClickedCheckSuperimposedSignal3()
{
    // TODO: Add your control notification handler code here

    OnBnClickedCheckSuperimposedSignal(3);
}


void CadqSignalGeneratorDlg::OnBnClickedCheckSuperimposedSignal4()
{
    // TODO: Add your control notification handler code here

    OnBnClickedCheckSuperimposedSignal(4);
}


void CadqSignalGeneratorDlg::OnBnClickedCheckSuperimposedSignal5()
{
    // TODO: Add your control notification handler code here

    OnBnClickedCheckSuperimposedSignal(5);
}


void CadqSignalGeneratorDlg::OnBnClickedCheckSuperimposedSignal6()
{
    // TODO: Add your control notification handler code here

    OnBnClickedCheckSuperimposedSignal(6);
}


void CadqSignalGeneratorDlg::OnBnClickedCheckSuperimposedSignal7()
{
    // TODO: Add your control notification handler code here

    OnBnClickedCheckSuperimposedSignal(7);
}


void CadqSignalGeneratorDlg::OnBnClickedButtonStartStop0()
{
    // TODO: Add your control notification handler code here

    OnBnClickedButtonStartStop(0);
}


void CadqSignalGeneratorDlg::OnBnClickedButtonStartStop1()
{
    // TODO: Add your control notification handler code here

    OnBnClickedButtonStartStop(1);
}


void CadqSignalGeneratorDlg::OnBnClickedButtonStartStop2()
{
    // TODO: Add your control notification handler code here

    OnBnClickedButtonStartStop(2);
}


void CadqSignalGeneratorDlg::OnBnClickedButtonStartStop3()
{
    // TODO: Add your control notification handler code here

    OnBnClickedButtonStartStop(3);
}


void CadqSignalGeneratorDlg::OnBnClickedButtonStartStop4()
{
    // TODO: Add your control notification handler code here

    OnBnClickedButtonStartStop(4);
}


void CadqSignalGeneratorDlg::OnBnClickedButtonStartStop5()
{
    // TODO: Add your control notification handler code here

    OnBnClickedButtonStartStop(5);
}


void CadqSignalGeneratorDlg::OnBnClickedButtonStartStop6()
{
    // TODO: Add your control notification handler code here

    OnBnClickedButtonStartStop(6);
}


void CadqSignalGeneratorDlg::OnBnClickedButtonStartStop7()
{
    // TODO: Add your control notification handler code here

    OnBnClickedButtonStartStop(7);
}


void CadqSignalGeneratorDlg::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct)
{
    // TODO: Add your message handler code here and/or call default

	if(lpDrawItemStruct->CtlType == ODT_BUTTON)
	{
		if( (IDC_BUTTON_START_STOP_0 <= lpDrawItemStruct->CtlID)&&(lpDrawItemStruct->CtlID <= IDC_BUTTON_START_STOP_7) )
        {
			UINT uStyle = DFCS_BUTTONPUSH;

			ASSERT(lpDrawItemStruct->CtlType == ODT_BUTTON);

			if(lpDrawItemStruct->itemState & ODS_SELECTED)
			{
			  uStyle |= DFCS_PUSHED;
			}

			// Draw the button frame.
			::DrawFrameControl(lpDrawItemStruct->hDC, &lpDrawItemStruct->rcItem, DFC_BUTTON, uStyle);

			lpDrawItemStruct->rcItem.left+= 2;
			
			lpDrawItemStruct->rcItem.top+= 2;
			
			lpDrawItemStruct->rcItem.right-= 2;
			
			lpDrawItemStruct->rcItem.bottom-= 2;
			
			COLORREF cr_color_button;

            unsigned int ui_index_signal = lpDrawItemStruct->CtlID - IDC_BUTTON_START_STOP_0;
			
			if(m_arrOutputSignals[ui_index_signal].m_bOutputRunning == 0)
			{
				cr_color_button = RGB(0x00, 0xC0, 0x00);
			}
			else
			{
				cr_color_button = RGB(0xC0, 0x00, 0x00);
			}

			HBRUSH h_brush = CreateSolidBrush(cr_color_button);
			
			FillRect(lpDrawItemStruct->hDC, &lpDrawItemStruct->rcItem, h_brush);

			DeleteObject(h_brush);
			
			COLORREF cr_color_text;
			
			cr_color_text = RGB(0x00, 0x00, 0x00);

			CString cs_text;
			
			if(m_arrOutputSignals[ui_index_signal].m_bOutputRunning == 0)
			{
				cs_text = _T("Start");
			}
			else
			{
				cs_text = _T("Stop");
			}

			COLORREF cr_old = SetTextColor(lpDrawItemStruct->hDC, cr_color_text);

			int old_bk_mode = SetBkMode(lpDrawItemStruct->hDC, TRANSPARENT);

			DrawText(	lpDrawItemStruct->hDC,			                // handle to DC
						cs_text,						                // text to draw	
						cs_text.GetLength(),			                // text length	
						&lpDrawItemStruct->rcItem,		                // formatting dimensions
						DT_CENTER | DT_SINGLELINE | DT_VCENTER		);  // text-drawing options

			SetBkMode(lpDrawItemStruct->hDC, old_bk_mode);

			SetTextColor(lpDrawItemStruct->hDC, cr_old);
        }
    }
      
    //    CDialogEx::OnDrawItem(nIDCtl, lpDrawItemStruct);
}


void CadqSignalGeneratorDlg::OnCancel()
{
    // TODO: Add your specialized code here and/or call the base class

    for(unsigned int ui_index_signal = 0; ui_index_signal < 8; ui_index_signal++)
    {
        if(m_arrOutputSignals[ui_index_signal].m_bOutputRunning != 0)
        {
            adqStop(m_arrOutputSignals[ui_index_signal].m_uiBoardIndex, m_arrOutputSignals[ui_index_signal].m_uiModuleIndex);

            WaitForSingleObject(m_arrOutputSignals[ui_index_signal].m_hThread, 1000);  // Wait upto 1 second for the thread to terminate
        }
    }

    CDialogEx::OnCancel();
}
