
// adqSignalGeneratorDlg.h : header file
//

#pragma once

#include "..\\adqDevice.h"

#ifdef WIN64

#pragma comment(lib, "..\\adqDevice_64.lib")

#else

#pragma comment(lib, "..\\adqDevice.lib")

#endif


// CadqSignalGeneratorDlg dialog
class CadqSignalGeneratorDlg : public CDialogEx
{
// Construction
public:
	CadqSignalGeneratorDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_ADQSIGNALGENERATOR_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

private:

    unsigned int m_uiNumberOfModules; 

    struct SAOModule
    {
        unsigned int    m_uiBoardIndex;

        wchar_t         m_wszBoardName[64];

        unsigned int    m_uiModuleIndex;

        unsigned int    m_uiNumberOfRanges;

        SADQAORange     m_arrRanges[ADQ_MAX_AO_RANGES];
    }
    *m_parrAOModules;

    // THis structure is passed to the thread which actually outputs the signal

    struct SOutputSignal
    {
        CadqSignalGeneratorDlg*  m_pSignalGeneratorDlg;

        unsigned int            m_uiSignalIndex;

        int                     m_bOutputRunning;

        unsigned int            m_uiBoardIndex;

        unsigned int            m_uiModuleIndex;

        double                  m_dActualFrequency;

        SADQAORange             m_sADQAORange;

        HANDLE                  m_hThread;
    }
    m_arrOutputSignals[8];

    void OnCbnSelchangeComboBoardAndModule(unsigned int uiOutputSignalIndex);

    void OnEnChangeEditRequiredFrequency(unsigned int uiOutputSignalIndex);

    void OnBnClickedCheckSuperimposedSignal(unsigned int uiOutputSignalIndex);

    void OnBnClickedButtonStartStop(unsigned int uiOutputSignalIndex);

    static unsigned int __stdcall OutputThread(void *);

public:
    afx_msg void OnCbnSelchangeComboBoardAndModule0();
    afx_msg void OnCbnSelchangeComboBoardAndModule1();
    afx_msg void OnCbnSelchangeComboBoardAndModule2();
    afx_msg void OnCbnSelchangeComboBoardAndModule3();
    afx_msg void OnCbnSelchangeComboBoardAndModule4();
    afx_msg void OnCbnSelchangeComboBoardAndModule5();
    afx_msg void OnCbnSelchangeComboBoardAndModule6();
    afx_msg void OnCbnSelchangeComboBoardAndModule7();
    afx_msg void OnEnChangeEditRequiredFrequency0();
    afx_msg void OnEnChangeEditRequiredFrequency1();
    afx_msg void OnEnChangeEditRequiredFrequency2();
    afx_msg void OnEnChangeEditRequiredFrequency3();
    afx_msg void OnEnChangeEditRequiredFrequency4();
    afx_msg void OnEnChangeEditRequiredFrequency5();
    afx_msg void OnEnChangeEditRequiredFrequency6();
    afx_msg void OnEnChangeEditRequiredFrequency7();
    afx_msg void OnBnClickedCheckSuperimposedSignal0();
    afx_msg void OnBnClickedCheckSuperimposedSignal1();
    afx_msg void OnBnClickedCheckSuperimposedSignal2();
    afx_msg void OnBnClickedCheckSuperimposedSignal3();
    afx_msg void OnBnClickedCheckSuperimposedSignal4();
    afx_msg void OnBnClickedCheckSuperimposedSignal5();
    afx_msg void OnBnClickedCheckSuperimposedSignal6();
    afx_msg void OnBnClickedCheckSuperimposedSignal7();
    afx_msg void OnBnClickedButtonStartStop0();
    afx_msg void OnBnClickedButtonStartStop1();
    afx_msg void OnBnClickedButtonStartStop2();
    afx_msg void OnBnClickedButtonStartStop3();
    afx_msg void OnBnClickedButtonStartStop4();
    afx_msg void OnBnClickedButtonStartStop5();
    afx_msg void OnBnClickedButtonStartStop6();
    afx_msg void OnBnClickedButtonStartStop7();
    afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct);
    virtual void OnCancel();
};
