
// adqSignalScopeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "adqSignalScope.h"
#include "adqSignalScopeDlg.h"
#include "afxdialogex.h"

#include "NonModalMessage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
    CAboutDlg();

// Dialog Data
    enum { IDD = IDD_ABOUTBOX };

    protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
    DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CadqSignalScopeDlg dialog



CadqSignalScopeDlg::CadqSignalScopeDlg(CWnd* pParent /*=NULL*/)
    : CDialogEx(CadqSignalScopeDlg::IDD, pParent)
{
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

    m_uiNumberOfModules = 0;

    m_parrAIModules = NULL;

    m_uiCurrentModuleIndex = 0;

    m_crPlotColor = RGB(0x00, 0x00, 0x00);

    m_bAcquisitionRunning = false;

    memset( &m_arrAIChannels[0], 0, 8 * sizeof(SAIChannel) );

    m_uiCurrentNumberOfChannels = 0;

    m_rectPlot.SetRectEmpty();

    // Internal variables

    m_bFirstDraw = true;;
    
    m_dXIncrement = 0.0;
    
    m_dXLastPixel = 0.0;
    
    m_iXLastPixel = 0;
}

void CadqSignalScopeDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CadqSignalScopeDlg, CDialogEx)
    ON_WM_SYSCOMMAND()
    ON_WM_PAINT()
    ON_WM_QUERYDRAGICON()
    ON_BN_CLICKED(IDC_CHECK_CHANNEL_0, &CadqSignalScopeDlg::OnBnClickedCheckChannel0)
    ON_BN_CLICKED(IDC_CHECK_CHANNEL_1, &CadqSignalScopeDlg::OnBnClickedCheckChannel1)
    ON_BN_CLICKED(IDC_CHECK_CHANNEL_2, &CadqSignalScopeDlg::OnBnClickedCheckChannel2)
    ON_BN_CLICKED(IDC_CHECK_CHANNEL_3, &CadqSignalScopeDlg::OnBnClickedCheckChannel3)
    ON_BN_CLICKED(IDC_CHECK_CHANNEL_4, &CadqSignalScopeDlg::OnBnClickedCheckChannel4)
    ON_BN_CLICKED(IDC_CHECK_CHANNEL_5, &CadqSignalScopeDlg::OnBnClickedCheckChannel5)
    ON_BN_CLICKED(IDC_CHECK_CHANNEL_6, &CadqSignalScopeDlg::OnBnClickedCheckChannel6)
    ON_BN_CLICKED(IDC_CHECK_CHANNEL_7, &CadqSignalScopeDlg::OnBnClickedCheckChannel7)
    ON_CBN_SELCHANGE(IDC_COMBO_MODULES, &CadqSignalScopeDlg::OnCbnSelchangeComboModules)
    ON_BN_CLICKED(IDC_SIGNAL_COLOR_0, &CadqSignalScopeDlg::OnBnClickedSignalColor0)
    ON_BN_CLICKED(IDC_SIGNAL_COLOR_1, &CadqSignalScopeDlg::OnBnClickedSignalColor1)
    ON_BN_CLICKED(IDC_SIGNAL_COLOR_2, &CadqSignalScopeDlg::OnBnClickedSignalColor2)
    ON_BN_CLICKED(IDC_SIGNAL_COLOR_3, &CadqSignalScopeDlg::OnBnClickedSignalColor3)
    ON_BN_CLICKED(IDC_SIGNAL_COLOR_4, &CadqSignalScopeDlg::OnBnClickedSignalColor4)
    ON_BN_CLICKED(IDC_SIGNAL_COLOR_5, &CadqSignalScopeDlg::OnBnClickedSignalColor5)
    ON_BN_CLICKED(IDC_SIGNAL_COLOR_6, &CadqSignalScopeDlg::OnBnClickedSignalColor6)
    ON_BN_CLICKED(IDC_SIGNAL_COLOR_7, &CadqSignalScopeDlg::OnBnClickedSignalColor7)
    ON_WM_DRAWITEM()
    ON_BN_CLICKED(ID_START_STOP, &CadqSignalScopeDlg::OnBnClickedStartStop)
    ON_BN_CLICKED(IDC_CHECK_TRIGGER_START_RISING_EDGE_0, &CadqSignalScopeDlg::OnBnClickedCheckTriggerStartRisingEdge0)
    ON_BN_CLICKED(IDC_CHECK_TRIGGER_START_RISING_EDGE_1, &CadqSignalScopeDlg::OnBnClickedCheckTriggerStartRisingEdge1)
    ON_BN_CLICKED(IDC_CHECK_TRIGGER_START_FALLING_EDGE_0, &CadqSignalScopeDlg::OnBnClickedCheckTriggerStartFallingEdge0)
    ON_BN_CLICKED(IDC_CHECK_TRIGGER_START_FALLING_EDGE_1, &CadqSignalScopeDlg::OnBnClickedCheckTriggerStartFallingEdge1)
    ON_BN_CLICKED(IDC_CHECK_START_TRIGGER_TIME_OUT, &CadqSignalScopeDlg::OnBnClickedCheckStartTriggerTimeOut)
    ON_BN_CLICKED(IDC_CHECK_TRIGGER_STOP_RISING_EDGE_0, &CadqSignalScopeDlg::OnBnClickedCheckTriggerStopRisingEdge0)
    ON_BN_CLICKED(IDC_CHECK_TRIGGER_STOP_RISING_EDGE_1, &CadqSignalScopeDlg::OnBnClickedCheckTriggerStopRisingEdge1)
    ON_BN_CLICKED(IDC_CHECK_TRIGGER_STOP_FALLING_EDGE_0, &CadqSignalScopeDlg::OnBnClickedCheckTriggerStopFallingEdge0)
    ON_BN_CLICKED(IDC_CHECK_TRIGGER_STOP_FALLING_EDGE_1, &CadqSignalScopeDlg::OnBnClickedCheckTriggerStopFallingEdge1)
END_MESSAGE_MAP()


// CadqSignalScopeDlg message handlers

BOOL CadqSignalScopeDlg::OnInitDialog()
{
    CDialogEx::OnInitDialog();

    // Add "About..." menu item to system menu.

    // IDM_ABOUTBOX must be in the system command range.
    ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
    ASSERT(IDM_ABOUTBOX < 0xF000);

    CMenu* pSysMenu = GetSystemMenu(FALSE);
    if (pSysMenu != NULL)
    {
        BOOL bNameValid;
        CString strAboutMenu;
        bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
        ASSERT(bNameValid);
        if (!strAboutMenu.IsEmpty())
        {
            pSysMenu->AppendMenu(MF_SEPARATOR);
            pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
        }
    }

    // Set the icon for this dialog.  The framework does this automatically
    //  when the application's main window is not a dialog
    SetIcon(m_hIcon, TRUE);			// Set big icon
    SetIcon(m_hIcon, FALSE);		// Set small icon

    // TODO: Add extra initialization here

    unsigned int ui_adq_error = adqOpen();

    CString cs_message;

    if(ui_adq_error != ADQ_ERROR_NONE)
    {
        cs_message.Format(  _T("adqOpen returned 0x%08X\n\n")
                             _T("Program will be terminated"), 
                            ui_adq_error                    );

        AfxMessageBox(cs_message, MB_OK | MB_ICONSTOP);

        EndDialog(IDCANCEL);

        return FALSE;
    }

    unsigned int ui_number_of_boards;
    
    ui_adq_error = adqGetNumberOfBoards(ui_number_of_boards);

    if(ui_adq_error != ADQ_ERROR_NONE)
    {
        cs_message.Format(  _T("adqGetNumberOfBoards returned 0x%08X\n\n") 
                             _T("Program will be terminated"), 
                            ui_adq_error                                    );

        AfxMessageBox(cs_message, MB_OK | MB_ICONSTOP);

        EndDialog(IDCANCEL);

        return FALSE;
    }

    if(ui_number_of_boards == 0)
    {
        cs_message.Format(  _T("No ADQ Boards found\n\n") 
                             _T("Program will be terminated"), 
                            ui_adq_error                                    );

        AfxMessageBox(cs_message, MB_OK | MB_ICONSTOP);

        EndDialog(IDCANCEL);

        return FALSE;
    }

    // Count the number of AI modules

    unsigned int m_uiNumberOfModules = 0;

    for(unsigned int ui_index_board = 0; ui_index_board < ui_number_of_boards; ui_index_board++)
    {
        unsigned int ui_number_of_modules;

        ui_adq_error = adqGetNumberOfModules(ui_index_board, ui_number_of_modules);

        if(ui_adq_error != ADQ_ERROR_NONE)
        {
            cs_message.Format(  _T("Board index: %3u adqGetNumberOfModules returned 0x%08X"), 
                                ui_index_board, ui_adq_error                                );

            AfxMessageBox(cs_message, MB_OK | MB_ICONEXCLAMATION);

            continue;
        }

        for(unsigned int ui_index_module = 0; ui_index_module < ui_number_of_modules; ui_index_module++)
        {
            unsigned int ui_module_type;

            ui_adq_error = adqGetModuleType(ui_index_board, ui_index_module, ui_module_type);

            if(ui_adq_error != ADQ_ERROR_NONE)
            {
                cs_message.Format(  _T("Board index: %3u Module index: %3u adqGetModuleType returned 0x%08X"), 
                                    ui_index_board, ui_index_module, ui_adq_error                            );

                AfxMessageBox(cs_message, MB_OK | MB_ICONEXCLAMATION);

                continue;
            }

            if(ui_module_type == ADQ_MODULE_TYPE_AI)
            {
                ++m_uiNumberOfModules;
            }
        }
    }

    if(m_uiNumberOfModules == 0)
    {
        cs_message.Format(  _T("No AI modules found") 
                             _T("Program will be terminated"), 
                            ui_adq_error                    );

        AfxMessageBox(cs_message, MB_OK | MB_ICONSTOP);

        EndDialog(IDCANCEL);

        return FALSE;
    }

    unsigned int ui_max_number_of_ai_modules = m_uiNumberOfModules;

    m_parrAIModules = new SAIModule[ui_max_number_of_ai_modules];

    m_uiNumberOfModules = 0;

    for(unsigned int ui_index_board = 0; ui_index_board < ui_number_of_boards; ui_index_board++)
    {
        unsigned int ui_number_of_modules;

        ui_adq_error = adqGetNumberOfModules(ui_index_board, ui_number_of_modules);

        if(ui_adq_error != ADQ_ERROR_NONE)
        {
            cs_message.Format(  _T("Board index: %3u adqGetNumberOfModules returned 0x%08X"), 
                                ui_index_board, ui_adq_error                                );

            AfxMessageBox(cs_message, MB_OK | MB_ICONEXCLAMATION);

            continue;
        }

        for(unsigned int ui_index_module = 0; ui_index_module < ui_number_of_modules; ui_index_module++)
        {
            unsigned int ui_module_type;

            ui_adq_error = adqGetModuleType(ui_index_board, ui_index_module, ui_module_type);

            if(ui_adq_error != ADQ_ERROR_NONE)
            {
                cs_message.Format(  _T("Board index: %3u Module index: %3u adqGetModuleType returned 0x%08X"), 
                                    ui_index_board, ui_index_module, ui_adq_error                            );

                AfxMessageBox(cs_message, MB_OK | MB_ICONEXCLAMATION);

                continue;
            }

            SADQGeneralModuleInfo s_adq_general_module_info;

            s_adq_general_module_info.m_uiSize = sizeof(SADQGeneralModuleInfo);

            s_adq_general_module_info.m_uiID = SADQGeneralModuleInfo_ID;

            if(ui_module_type == ADQ_MODULE_TYPE_AI)
            {
                SADQBoardInfo s_adq_board_info;

                s_adq_board_info.m_uiSize = sizeof(SADQBoardInfo);

                s_adq_board_info.m_uiID = SADQBoardInfo_ID;

                ui_adq_error = adqGetBoardInfo(ui_index_board, s_adq_board_info);

                if(ui_adq_error != ADQ_ERROR_NONE)
                {
                    cs_message.Format(  _T("Board index: %3u adqGetBoardInfo returned 0x%08X"), 
                                        ui_index_board, ui_adq_error                            );

                    AfxMessageBox(cs_message, MB_OK | MB_ICONEXCLAMATION);

                    continue;
                }

                SADQHWTriggerInfo s_adq_hw_trigger_info;

                s_adq_hw_trigger_info.m_uiSize = sizeof(SADQHWTriggerInfo);

                s_adq_hw_trigger_info.m_uiID = SADQHWTriggerInfo_ID;

                ui_adq_error = adqGetHWTriggerInfo(ui_index_board, ui_index_module, s_adq_hw_trigger_info);

                if(ui_adq_error != ADQ_ERROR_NONE)
                {
                    cs_message.Format(  _T("Board index: %3u Module index: %3u adqGetHWTriggerInfo returned 0x%08X"), 
                                        ui_index_board, ui_index_module, ui_adq_error                               );

                    AfxMessageBox(cs_message, MB_OK | MB_ICONEXCLAMATION);

                    continue;
                }

                SADQAIModuleInfo s_adq_ai_module_info;

                s_adq_ai_module_info.m_uiSize = sizeof(SADQAIModuleInfo);

                s_adq_ai_module_info.m_uiID = SADQAIModuleInfo_ID;

                unsigned int ui_info_size;

                ui_adq_error = adqGetModuleInfo(ui_index_board, ui_index_module, s_adq_general_module_info, sizeof(SADQAIModuleInfo), (unsigned char*)&s_adq_ai_module_info, ui_info_size);

                if(ui_adq_error != ADQ_ERROR_NONE)
                {
                    cs_message.Format(  _T("Board index: %3u Module index: %3u adqGetModuleInfo returned 0x%08X"), 
                                        ui_index_board, ui_index_module, ui_adq_error                            );

                    AfxMessageBox(cs_message, MB_OK | MB_ICONEXCLAMATION);

                    continue;
                }

                m_parrAIModules[m_uiNumberOfModules].m_uiBoardIndex = ui_index_board;

                wcscpy_s( &m_parrAIModules[m_uiNumberOfModules].m_wszBoardName[0], 64, &s_adq_board_info.m_wszBoardName[0] );

                m_parrAIModules[m_uiNumberOfModules].m_uiModuleIndex = ui_index_module;

                m_parrAIModules[m_uiNumberOfModules].m_uiNumberOfChannels = s_adq_ai_module_info.m_uiNumberOfChannels;

                m_parrAIModules[m_uiNumberOfModules].m_bSharedDataRate = s_adq_ai_module_info.m_bSharedDataRate;

                m_parrAIModules[m_uiNumberOfModules].m_bRangeInfoPerChannel = s_adq_ai_module_info.m_bRangeInfoPerChannel;

                m_parrAIModules[m_uiNumberOfModules].m_uiNumberOfRanges = s_adq_ai_module_info.m_uiNumberOfRanges;

                memcpy( &m_parrAIModules[m_uiNumberOfModules].m_arrRanges[0],  &s_adq_ai_module_info.m_arrRanges[0], m_parrAIModules[m_uiNumberOfModules].m_uiNumberOfRanges * sizeof(SADQAIRange) );

                m_parrAIModules[m_uiNumberOfModules].m_uiHWTriggerStartSource = s_adq_hw_trigger_info.m_uiHWTriggerStartSource;

                m_parrAIModules[m_uiNumberOfModules].m_uiHWTriggerStopSource = s_adq_hw_trigger_info.m_uiHWTriggerStopSource;

                m_parrAIModules[m_uiNumberOfModules].m_bSupportsChannelListPerTrigger = s_adq_hw_trigger_info.m_bSupportsChannelListPerTrigger ? 1 : 0;

                ++m_uiNumberOfModules;
            }
        }
    }

    GetDlgItem(IDC_PLOT)->GetClientRect(m_rectPlot);
    
    GetDlgItem(IDC_PLOT)->ClientToScreen(m_rectPlot);
    
    ScreenToClient(m_rectPlot);
    
    m_rectPlot.DeflateRect(1, 1);

    CComboBox* p_module_combo = (CComboBox*)GetDlgItem(IDC_COMBO_MODULES);

    CString cs_module;

    for(unsigned int index_module = 0; index_module < m_uiNumberOfModules; index_module++)
    {

        cs_module.Format(   _T("Board index %u (%s), Module Index: %u"), 
                            m_parrAIModules[index_module].m_uiBoardIndex, 
                            &m_parrAIModules[index_module].m_wszBoardName[0], 
                            m_parrAIModules[index_module].m_uiModuleIndex   );

        p_module_combo->AddString(cs_module);
    }

    p_module_combo->SetCurSel(0);

    OnCbnSelchangeComboModules();

    return TRUE;  // return TRUE  unless you set the focus to a control
}

void CadqSignalScopeDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
    if ((nID & 0xFFF0) == IDM_ABOUTBOX)
    {
        CAboutDlg dlgAbout;
        dlgAbout.DoModal();
    }
    else
    {
        CDialogEx::OnSysCommand(nID, lParam);
    }
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CadqSignalScopeDlg::OnPaint()
{
    if (IsIconic())
    {
        CPaintDC dc(this); // device context for painting

        SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

        // Center icon in client rectangle
        int cxIcon = GetSystemMetrics(SM_CXICON);
        int cyIcon = GetSystemMetrics(SM_CYICON);
        CRect rect;
        GetClientRect(&rect);
        int x = (rect.Width() - cxIcon + 1) / 2;
        int y = (rect.Height() - cyIcon + 1) / 2;

        // Draw the icon
        dc.DrawIcon(x, y, m_hIcon);
    }
    else
    {
        CDialogEx::OnPaint();
    }
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CadqSignalScopeDlg::OnQueryDragIcon()
{
    return static_cast<HCURSOR>(m_hIcon);
}



void CadqSignalScopeDlg::OnBnClickedCheckChannel0()
{
    // TODO: Add your control notification handler code here

    OnBnClickedCheckChannel(0);
}


void CadqSignalScopeDlg::OnBnClickedCheckChannel1()
{
    // TODO: Add your control notification handler code here

    OnBnClickedCheckChannel(1);
}


void CadqSignalScopeDlg::OnBnClickedCheckChannel2()
{
    // TODO: Add your control notification handler code here

    OnBnClickedCheckChannel(2);
}


void CadqSignalScopeDlg::OnBnClickedCheckChannel3()
{
    // TODO: Add your control notification handler code here

    OnBnClickedCheckChannel(3);
}


void CadqSignalScopeDlg::OnBnClickedCheckChannel4()
{
    // TODO: Add your control notification handler code here

    OnBnClickedCheckChannel(4);
}


void CadqSignalScopeDlg::OnBnClickedCheckChannel5()
{
    // TODO: Add your control notification handler code here

    OnBnClickedCheckChannel(5);
}


void CadqSignalScopeDlg::OnBnClickedCheckChannel6()
{
    // TODO: Add your control notification handler code here

    OnBnClickedCheckChannel(6);
}


void CadqSignalScopeDlg::OnBnClickedCheckChannel7()
{
    // TODO: Add your control notification handler code here

    OnBnClickedCheckChannel(7);
}


void CadqSignalScopeDlg::OnCbnSelchangeComboModules()
{
    // TODO: Add your control notification handler code here

    CComboBox* p_module_combo = (CComboBox*)GetDlgItem(IDC_COMBO_MODULES);

    m_uiCurrentModuleIndex = (unsigned int)p_module_combo->GetCurSel();

    unsigned int ui_trigger_mask = 0x00000001;

    for(unsigned int ui_trigger_index = 0; ui_trigger_index < 2; ui_trigger_index++)
    {
        CheckDlgButton(IDC_CHECK_TRIGGER_START_RISING_EDGE_0 + ui_trigger_index, BST_UNCHECKED);

        CheckDlgButton(IDC_CHECK_TRIGGER_START_FALLING_EDGE_0 + ui_trigger_index, BST_UNCHECKED);

        if( (m_parrAIModules[m_uiCurrentModuleIndex].m_uiHWTriggerStartSource & ui_trigger_mask) == ui_trigger_mask )
        {
            GetDlgItem(IDC_CHECK_TRIGGER_START_RISING_EDGE_0 + ui_trigger_index)->ShowWindow(SW_SHOW);

            GetDlgItem(IDC_CHECK_TRIGGER_START_FALLING_EDGE_0 + ui_trigger_index)->ShowWindow(SW_SHOW);
        }
        else
        {
            GetDlgItem(IDC_CHECK_TRIGGER_START_RISING_EDGE_0 + ui_trigger_index)->ShowWindow(SW_HIDE);

            GetDlgItem(IDC_CHECK_TRIGGER_START_FALLING_EDGE_0 + ui_trigger_index)->ShowWindow(SW_HIDE);
        }

        ui_trigger_mask<<= 1;
    }

    CheckDlgButton(IDC_CHECK_DATA_FRAME_PER_TRIGGER, BST_UNCHECKED);

    CheckDlgButton(IDC_CHECK_START_TRIGGER_TIME_OUT, BST_UNCHECKED);

    SetDlgItemInt(IDC_EDIT_START_TRIGGER_TIME_OUT, 1000, 0);

    GetDlgItem(IDC_CHECK_DATA_FRAME_PER_TRIGGER)->EnableWindow(FALSE);

    GetDlgItem(IDC_CHECK_START_TRIGGER_TIME_OUT)->EnableWindow(FALSE);

    GetDlgItem(IDC_EDIT_START_TRIGGER_TIME_OUT)->EnableWindow(FALSE);

    ui_trigger_mask = 0x00000001;

    for(unsigned int ui_trigger_index = 0; ui_trigger_index < 2; ui_trigger_index++)
    {
        CheckDlgButton(IDC_CHECK_TRIGGER_STOP_RISING_EDGE_0 + ui_trigger_index, BST_UNCHECKED);

        CheckDlgButton(IDC_CHECK_TRIGGER_STOP_FALLING_EDGE_0 + ui_trigger_index, BST_UNCHECKED);

        if( (m_parrAIModules[m_uiCurrentModuleIndex].m_uiHWTriggerStopSource & ui_trigger_mask) == ui_trigger_mask )
        {
            GetDlgItem(IDC_CHECK_TRIGGER_STOP_RISING_EDGE_0 + ui_trigger_index)->ShowWindow(SW_SHOW);

            GetDlgItem(IDC_CHECK_TRIGGER_STOP_FALLING_EDGE_0 + ui_trigger_index)->ShowWindow(SW_SHOW);
        }
        else
        {
            GetDlgItem(IDC_CHECK_TRIGGER_STOP_RISING_EDGE_0 + ui_trigger_index)->ShowWindow(SW_HIDE);

            GetDlgItem(IDC_CHECK_TRIGGER_STOP_FALLING_EDGE_0 + ui_trigger_index)->ShowWindow(SW_HIDE);
        }

        ui_trigger_mask<<= 1;
    }

    if(m_parrAIModules[m_uiCurrentModuleIndex].m_bSupportsChannelListPerTrigger == 0)
    {
        GetDlgItem(IDC_CHECK_DATA_FRAME_PER_TRIGGER)->ShowWindow(SW_HIDE);
    }
    else
    {
        GetDlgItem(IDC_CHECK_DATA_FRAME_PER_TRIGGER)->ShowWindow(SW_SHOW);
    }

    GetDlgItem(IDC_CHECK_REARM)->ShowWindow(SW_HIDE);

    for(unsigned int channel_index = 0; channel_index < 8; channel_index++)
    {
        GetDlgItem(IDC_CHECK_CHANNEL_0 + channel_index)->ShowWindow(channel_index < m_parrAIModules[m_uiCurrentModuleIndex].m_uiNumberOfChannels);
        
        GetDlgItem(IDC_COMBO_CHANNEL_NUMBER_0 + channel_index)->ShowWindow(channel_index < m_parrAIModules[m_uiCurrentModuleIndex].m_uiNumberOfChannels);
        
        GetDlgItem(IDC_SIGNAL_COLOR_0 + channel_index)->ShowWindow(channel_index < m_parrAIModules[m_uiCurrentModuleIndex].m_uiNumberOfChannels);
        
        GetDlgItem(IDC_SIGNAL_COLOR_DISPLAY_0 + channel_index)->ShowWindow(channel_index < m_parrAIModules[m_uiCurrentModuleIndex].m_uiNumberOfChannels);
        
        GetDlgItem(IDC_COMBO_RANGE_0 + channel_index)->ShowWindow(channel_index < m_parrAIModules[m_uiCurrentModuleIndex].m_uiNumberOfChannels);
        
        GetDlgItem(IDC_EDIT_DISPLAY_MIN_0 + channel_index)->ShowWindow(channel_index < m_parrAIModules[m_uiCurrentModuleIndex].m_uiNumberOfChannels);
        
        GetDlgItem(IDC_DISPLAY_MIN_UNIT_0 + channel_index)->ShowWindow(channel_index < m_parrAIModules[m_uiCurrentModuleIndex].m_uiNumberOfChannels);
        
        GetDlgItem(IDC_EDIT_DISPLAY_MAX_0 + channel_index)->ShowWindow(channel_index < m_parrAIModules[m_uiCurrentModuleIndex].m_uiNumberOfChannels);
        
        GetDlgItem(IDC_DISPLAY_MAX_UNIT_0 + channel_index)->ShowWindow(channel_index < m_parrAIModules[m_uiCurrentModuleIndex].m_uiNumberOfChannels);

        if( channel_index < m_parrAIModules[m_uiCurrentModuleIndex].m_uiNumberOfChannels )
        {
            CheckDlgButton( IDC_CHECK_CHANNEL_0 + channel_index, ( (channel_index == 0) ? BST_CHECKED : BST_UNCHECKED) );
            
            CComboBox* p_channel_combo = (CComboBox*)GetDlgItem(IDC_COMBO_CHANNEL_NUMBER_0 + channel_index);

            p_channel_combo->ResetContent();

            for(unsigned int index_ai_channel = 0; index_ai_channel < m_parrAIModules[m_uiCurrentModuleIndex].m_uiNumberOfChannels; index_ai_channel++)
            {
                CString cs_entry;

                cs_entry.Format( _T("%u"), index_ai_channel );

                p_channel_combo->AddString(cs_entry);
            }

            p_channel_combo->SetCurSel( (int)channel_index );

            CMFCColorButton* p_color_button = (CMFCColorButton*)GetDlgItem(IDC_SIGNAL_COLOR_0 + channel_index);

            p_color_button->SetColor( m_crDefaultSignalColor[channel_index] );

            GetDlgItem(IDC_SIGNAL_COLOR_DISPLAY_0 + channel_index)->Invalidate();

            TCHAR* tsz_unit = NULL;
            
            switch(m_parrAIModules[m_uiCurrentModuleIndex].m_arrRanges[0].m_uiPhysicalUnit)
            {
            case ADQ_PHYSICAL_UNIT_VOLT:

                tsz_unit = _T("V");

                break;

            case ADQ_PHYSICAL_UNIT_AMPERE:

                tsz_unit = _T("A");

                break;

            case ADQ_PHYSICAL_UNIT_OHM:

                tsz_unit = _T("O");

                break;

            default:

                tsz_unit = _T("?");

                break;
            }
            
            CComboBox* p_range_combo = (CComboBox*)GetDlgItem(IDC_COMBO_RANGE_0 + channel_index);

            p_range_combo->ResetContent();

            for(unsigned int index_range = 0; index_range < m_parrAIModules[m_uiCurrentModuleIndex].m_uiNumberOfRanges; index_range++)
            {
                CString cs_entry;

                cs_entry.Format(_T("%8.3f %s - %8.3f %s"), 
                                m_parrAIModules[m_uiCurrentModuleIndex].m_arrRanges[index_range].m_dPhysicalMin,
                                tsz_unit, 
                                m_parrAIModules[m_uiCurrentModuleIndex].m_arrRanges[index_range].m_dPhysicalMax,
                                tsz_unit                                                                        );

                p_range_combo->AddString(cs_entry);
            }

            p_range_combo->SetCurSel(0);

            CString cs_value;

            cs_value.Format( _T("%8.3f"), m_parrAIModules[m_uiCurrentModuleIndex].m_arrRanges[0].m_dPhysicalMin );

            GetDlgItem(IDC_EDIT_DISPLAY_MIN_0 + channel_index)->SetWindowText(cs_value);

            GetDlgItem(IDC_DISPLAY_MIN_UNIT_0 + channel_index)->SetWindowText(tsz_unit);

            cs_value.Format( _T("%8.3f"), m_parrAIModules[m_uiCurrentModuleIndex].m_arrRanges[0].m_dPhysicalMax );

            GetDlgItem(IDC_EDIT_DISPLAY_MAX_0 + channel_index)->SetWindowText(cs_value);

            GetDlgItem(IDC_DISPLAY_MAX_UNIT_0 + channel_index)->SetWindowText(tsz_unit);

            OnBnClickedCheckChannel(channel_index);
        }
    }



    SetDlgItemText( IDC_EDIT_SAMPLING_RATE_REQUIRED, _T("100.0") );

    SetDlgItemText( IDC_EDIT_WINDOW_WIDTH_SECONDS, _T("4.0") );
}

void CadqSignalScopeDlg::OnBnClickedCheckChannel(unsigned int uiChannelIndex)
{
    BOOL b_enable = IsDlgButtonChecked(IDC_CHECK_CHANNEL_0 + uiChannelIndex) == BST_CHECKED ? TRUE : FALSE;
    
    GetDlgItem(IDC_COMBO_CHANNEL_NUMBER_0 + uiChannelIndex)->EnableWindow(b_enable);
        
    GetDlgItem(IDC_SIGNAL_COLOR_0 + uiChannelIndex)->EnableWindow(b_enable);
        
    GetDlgItem(IDC_SIGNAL_COLOR_DISPLAY_0 + uiChannelIndex)->EnableWindow(b_enable);
        
    GetDlgItem(IDC_COMBO_RANGE_0 + uiChannelIndex)->EnableWindow(b_enable);
        
    GetDlgItem(IDC_EDIT_DISPLAY_MIN_0 + uiChannelIndex)->EnableWindow(b_enable);
        
    GetDlgItem(IDC_DISPLAY_MIN_UNIT_0 + uiChannelIndex)->EnableWindow(b_enable);
        
    GetDlgItem(IDC_EDIT_DISPLAY_MAX_0 + uiChannelIndex)->EnableWindow(b_enable);
        
    GetDlgItem(IDC_DISPLAY_MAX_UNIT_0 + uiChannelIndex)->EnableWindow(b_enable);
}


void CadqSignalScopeDlg::OnBnClickedSignalColor0()
{
    // TODO: Add your control notification handler code here

    OnBnClickedSignalColor(0);
}


void CadqSignalScopeDlg::OnBnClickedSignalColor1()
{
    // TODO: Add your control notification handler code here

    OnBnClickedSignalColor(1);
}


void CadqSignalScopeDlg::OnBnClickedSignalColor2()
{
    // TODO: Add your control notification handler code here

    OnBnClickedSignalColor(2);
}


void CadqSignalScopeDlg::OnBnClickedSignalColor3()
{
    // TODO: Add your control notification handler code here

    OnBnClickedSignalColor(3);
}


void CadqSignalScopeDlg::OnBnClickedSignalColor4()
{
    // TODO: Add your control notification handler code here

    OnBnClickedSignalColor(4);
}


void CadqSignalScopeDlg::OnBnClickedSignalColor5()
{
    // TODO: Add your control notification handler code here

    OnBnClickedSignalColor(5);
}


void CadqSignalScopeDlg::OnBnClickedSignalColor6()
{
    // TODO: Add your control notification handler code here

    OnBnClickedSignalColor(6);
}


void CadqSignalScopeDlg::OnBnClickedSignalColor7()
{
    // TODO: Add your control notification handler code here

    OnBnClickedSignalColor(7);
}

void CadqSignalScopeDlg::OnBnClickedSignalColor(unsigned int uiChannelIndex)
{
    GetDlgItem(IDC_SIGNAL_COLOR_DISPLAY_0 + uiChannelIndex)->Invalidate();
}




void CadqSignalScopeDlg::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct)
{
    // TODO: Add your message handler code here and/or call default

    if( (IDC_SIGNAL_COLOR_DISPLAY_0 <= nIDCtl)&&(nIDCtl <= IDC_SIGNAL_COLOR_DISPLAY_0 + 7) )
    {
        unsigned int ui_index_channel = (unsigned int)(nIDCtl - IDC_SIGNAL_COLOR_DISPLAY_0);

        HBRUSH h_brush = CreateSolidBrush(m_crPlotColor);
            
        FillRect(lpDrawItemStruct->hDC, &lpDrawItemStruct->rcItem, h_brush);

        DeleteObject(h_brush);

        COLORREF cr_pen_color = ( (CMFCColorButton*)GetDlgItem(IDC_SIGNAL_COLOR_0 + ui_index_channel) )->GetColor();

        HPEN h_pen = CreatePen(PS_SOLID, 0, cr_pen_color);

        HGDIOBJ h_old_pen = SelectObject(lpDrawItemStruct->hDC, h_pen);

        int y_pix;
        
        if( (ui_index_channel % 2) == 0 )
        {
            y_pix = (lpDrawItemStruct->rcItem.top + 4 * lpDrawItemStruct->rcItem.bottom) / 5;
        }
        else
        {
            y_pix = (4 * lpDrawItemStruct->rcItem.top + lpDrawItemStruct->rcItem.bottom) / 5;
        }

        MoveToEx(lpDrawItemStruct->hDC, lpDrawItemStruct->rcItem.left, y_pix, NULL);
        
        if( (ui_index_channel % 2) == 0 )
        {
            y_pix = (4 * lpDrawItemStruct->rcItem.top + lpDrawItemStruct->rcItem.bottom) / 5;
        }
        else
        {
            y_pix = (lpDrawItemStruct->rcItem.top + 4 * lpDrawItemStruct->rcItem.bottom) / 5;
        }

        LineTo(lpDrawItemStruct->hDC, lpDrawItemStruct->rcItem.right, y_pix);

        SelectObject(lpDrawItemStruct->hDC, h_old_pen);
    }
    else if(nIDCtl == ID_START_STOP)
    {
        UINT uStyle = DFCS_BUTTONPUSH;

        ASSERT(lpDrawItemStruct->CtlType == ODT_BUTTON);

        if(lpDrawItemStruct->itemState & ODS_SELECTED)
        {
            uStyle |= DFCS_PUSHED;
        }

        // Draw the button frame.
        ::DrawFrameControl(lpDrawItemStruct->hDC, &lpDrawItemStruct->rcItem, DFC_BUTTON, uStyle);

        lpDrawItemStruct->rcItem.left+= 2;
            
        lpDrawItemStruct->rcItem.top+= 2;
            
        lpDrawItemStruct->rcItem.right-= 2;
            
        lpDrawItemStruct->rcItem.bottom-= 2;
            
        COLORREF cr_color_button;

        if(m_bAcquisitionRunning)
        {
            cr_color_button = RGB(0xC0, 0x00, 0x00);
        }
        else
        {
            cr_color_button = RGB(0x00, 0xC0, 0x00);
        }

        HBRUSH h_brush = CreateSolidBrush(cr_color_button);
            
        FillRect(lpDrawItemStruct->hDC, &lpDrawItemStruct->rcItem, h_brush);

        DeleteObject(h_brush);
            
        COLORREF cr_color_text;
            
        cr_color_text = RGB(0x00, 0x00, 0x00);

        CString cs_text;
            
        if(m_bAcquisitionRunning)
        {
            cs_text = _T("Stop");
        }
        else
        {
            cs_text = _T("Start");
        }

        COLORREF cr_old = SetTextColor(lpDrawItemStruct->hDC, cr_color_text);

        int old_bk_mode = SetBkMode(lpDrawItemStruct->hDC, TRANSPARENT);

        DrawText(	lpDrawItemStruct->hDC,			                // handle to DC
                    cs_text,						                // text to draw	
                    cs_text.GetLength(),			                // text length	
                    &lpDrawItemStruct->rcItem,		                // formatting dimensions
                    DT_CENTER | DT_SINGLELINE | DT_VCENTER		);  // text-drawing options

        SetBkMode(lpDrawItemStruct->hDC, old_bk_mode);

        SetTextColor(lpDrawItemStruct->hDC, cr_old);
    }
    else
    {
       CDialogEx::OnDrawItem(nIDCtl, lpDrawItemStruct);
    }
}

void CadqSignalScopeDlg::OnBnClickedStartStop()
{
    // TODO: Add your control notification handler code here

    TCHAR tsz_sampling_rate[64];

    if(m_bAcquisitionRunning)
    {
        adqStop(m_parrAIModules[m_uiCurrentModuleIndex].m_uiBoardIndex, m_parrAIModules[m_uiCurrentModuleIndex].m_uiModuleIndex);

        _stprintf( &tsz_sampling_rate[0], _T("Actual sampling rate: ???? Hz") );
        
        SetDlgItemText( IDC_STATIC_ACTUAL_SAMPLING_RATE, &tsz_sampling_rate[0] );

        m_bAcquisitionRunning = false;
    }
    else
    {
        CClientDC dc(this);

        dc.FillSolidRect( m_rectPlot, m_crPlotColor );

        SADQAIChannel* arr_sadq_channel = new SADQAIChannel[m_parrAIModules[m_uiCurrentModuleIndex].m_uiNumberOfChannels];

        memset( &arr_sadq_channel[0], 0, m_parrAIModules[m_uiCurrentModuleIndex].m_uiNumberOfChannels * sizeof(SADQAIChannel) );

        memset( &m_arrAIChannels[0], 0, 8 * sizeof(SAIChannel) );

        m_uiCurrentNumberOfChannels = 0;

        CString cs_message;
                    
        for(unsigned int ui_index_display_channel = 0; ui_index_display_channel < 8; ui_index_display_channel++)
        {
            if( IsDlgButtonChecked(IDC_CHECK_CHANNEL_0 + ui_index_display_channel) == BST_CHECKED )
            {
                CComboBox* p_channel_combo = (CComboBox*)GetDlgItem(IDC_COMBO_CHANNEL_NUMBER_0 + ui_index_display_channel);

                unsigned int ui_index_ai_channel = (unsigned int)p_channel_combo->GetCurSel();

                if(arr_sadq_channel[ui_index_ai_channel].m_bAcquireChannel)
                {
                    // This channel has already been chosen for display

                    cs_message.Format(  _T("AI channel %u has been used more than once"), 
                                        ui_index_ai_channel                                );

                    AfxMessageBox(cs_message, MB_OK | MB_ICONEXCLAMATION);

                    return;
                }

                arr_sadq_channel[ui_index_ai_channel].m_bAcquireChannel = true;

                CComboBox* p_range_combo = (CComboBox*)GetDlgItem(IDC_COMBO_RANGE_0 + ui_index_display_channel);

                unsigned int ui_index_range = (unsigned int)p_range_combo->GetCurSel();

                arr_sadq_channel[ui_index_ai_channel].m_uiRangeIndex = ui_index_range;

                m_arrAIChannels[m_uiCurrentNumberOfChannels].m_uiChannelIndex = ui_index_ai_channel;

                CMFCColorButton* p_color_button = (CMFCColorButton*)GetDlgItem(IDC_SIGNAL_COLOR_0 + ui_index_display_channel);

                m_arrAIChannels[m_uiCurrentNumberOfChannels].m_crPlotColor = p_color_button->GetColor();

                double d_digital_min = m_parrAIModules[m_uiCurrentModuleIndex].m_arrRanges[ui_index_range].m_uiDigitalMin;

                double d_digital_max = m_parrAIModules[m_uiCurrentModuleIndex].m_arrRanges[ui_index_range].m_uiDigitalMax;

                double d_physical_min = m_parrAIModules[m_uiCurrentModuleIndex].m_arrRanges[ui_index_range].m_dPhysicalMin;

                double d_physical_max = m_parrAIModules[m_uiCurrentModuleIndex].m_arrRanges[ui_index_range].m_dPhysicalMax;

                double d_digital_to_physical_factor = (d_physical_max - d_physical_min) / (double)(d_digital_max - d_digital_min);

                double d_digital_to_physical_constant = d_physical_min - d_digital_min * d_digital_to_physical_factor;

                TCHAR tsz_display_physical_limit[64];

                GetDlgItemText(IDC_EDIT_DISPLAY_MIN_0 + ui_index_display_channel, &tsz_display_physical_limit[0], 64);

                double d_display_physical_min;

                if( _stscanf(&tsz_display_physical_limit[0], _T("%lf"), &d_display_physical_min) != 1 )
                {
                    cs_message.Format(  _T("Display channel %u - Invalid Display Min."), 
                                        ui_index_display_channel + 1                                );

                    AfxMessageBox(cs_message, MB_OK | MB_ICONEXCLAMATION);

                    return;
                }

                GetDlgItemText(IDC_EDIT_DISPLAY_MAX_0 + ui_index_display_channel, &tsz_display_physical_limit[0], 64);

                double d_display_physical_max;

                if( _stscanf(&tsz_display_physical_limit[0], _T("%lf"), &d_display_physical_max) != 1 )
                {
                    cs_message.Format(  _T("Display channel %u - Invalid Display Max."), 
                                        ui_index_display_channel + 1                                );

                    AfxMessageBox(cs_message, MB_OK | MB_ICONEXCLAMATION);

                    return;
                }

                if(d_display_physical_min == d_display_physical_max)
                {
                    cs_message.Format(  _T("Display channel %u - Display Min. == Display Max."), 
                                        ui_index_display_channel + 1                            );

                    AfxMessageBox(cs_message, MB_OK | MB_ICONEXCLAMATION);

                    return;
                }

                double d_physical_to_pixel_factor = -(double)m_rectPlot.Height() / (d_display_physical_max - d_display_physical_min);

                double d_physical_to_pixel_constant = (double)m_rectPlot.bottom - d_display_physical_min * d_physical_to_pixel_factor;

                // Y = F1 * X + K1
                // Z = F2 * Y + K2
                // ===> Z = F1 * F2 * X + F2 * K1 + K2

                m_arrAIChannels[m_uiCurrentNumberOfChannels].m_dDigitalToPixelFactor = d_digital_to_physical_factor * d_physical_to_pixel_factor;

                m_arrAIChannels[m_uiCurrentNumberOfChannels].m_dDigitalToPixelConstant = d_physical_to_pixel_factor * d_digital_to_physical_constant + d_physical_to_pixel_constant;

                ++m_uiCurrentNumberOfChannels;
            }
        }

        // Sort the array m_arrAIChannels in ascending order of the channel index.
        // This is the order in which ADQ will deliver the acquired data.

        for(unsigned int ui_index_1 = 0; ui_index_1 < m_uiCurrentNumberOfChannels - 1; ui_index_1++)
        {
            for(unsigned int ui_index_2 = 0; ui_index_2 < m_uiCurrentNumberOfChannels - ui_index_1 - 1; ui_index_2++)
            {
                if(m_arrAIChannels[ui_index_2].m_uiChannelIndex > m_arrAIChannels[ui_index_2 + 1].m_uiChannelIndex)
                {
                    SAIChannel s_ai_channel = m_arrAIChannels[ui_index_2];

                    m_arrAIChannels[ui_index_2] = m_arrAIChannels[ui_index_2 + 1];

                    m_arrAIChannels[ui_index_2 + 1] = s_ai_channel;
                }
            }
        }

        GetDlgItemText(IDC_EDIT_SAMPLING_RATE_REQUIRED, &tsz_sampling_rate[0], 64);

        double d_required_sampling_rate;
    
        if( _stscanf(&tsz_sampling_rate[0], _T("%lf"), &d_required_sampling_rate) != 1 )
        {
            AfxMessageBox( _T("Invalid sampling rate"), MB_OK | MB_ICONEXCLAMATION );

            return;
        }

        double d_acheived_freq;

        unsigned int ui_adq_error = adqAISetChannelListAndFrequency(m_parrAIModules[m_uiCurrentModuleIndex].m_uiBoardIndex, m_parrAIModules[m_uiCurrentModuleIndex].m_uiModuleIndex, &arr_sadq_channel[0], m_parrAIModules[m_uiCurrentModuleIndex].m_uiNumberOfChannels, d_required_sampling_rate, d_acheived_freq);

        if(ui_adq_error != ADQ_ERROR_NONE)
        {
            cs_message.Format(  _T("adqAISetChannelListAndFrequency returned 0x%08X"), 
                                ui_adq_error                                            );

            AfxMessageBox(cs_message, MB_OK | MB_ICONEXCLAMATION);

            return;
        }

        delete[] arr_sadq_channel;

        TCHAR tsz_window_width_seconds[64];

        GetDlgItemText(IDC_EDIT_WINDOW_WIDTH_SECONDS, &tsz_window_width_seconds[0], 64);

        double d_window_width_seconds;

        if( ( _stscanf(&tsz_window_width_seconds[0], _T("%lf"), &d_window_width_seconds) != 1 )||(d_window_width_seconds <= 0.0) )
        {
            AfxMessageBox( _T("Invalid Window width"), MB_OK | MB_ICONEXCLAMATION );

            return;
        }

        m_dXIncrement = (double)m_rectPlot.Width() / (d_acheived_freq * d_window_width_seconds);

        m_dXLastPixel = (double)m_rectPlot.left;
    
        m_iXLastPixel = m_rectPlot.left;

        m_bFirstDraw = true;

        // Enable / disable the hardware trigger 

        int b_wait_start_trigger = 0;

        if( (m_parrAIModules[m_uiCurrentModuleIndex].m_uiHWTriggerStartSource != 0x00000000)||(m_parrAIModules[m_uiCurrentModuleIndex].m_uiHWTriggerStopSource != 0x00000000) )
        {
            SADQHWTriggerEnable s_adq_hw_trigger_enable;

            memset( &s_adq_hw_trigger_enable, 0, sizeof(SADQHWTriggerEnable) );

            s_adq_hw_trigger_enable.m_uiSize = sizeof(SADQHWTriggerEnable);

            s_adq_hw_trigger_enable.m_uiID = SADQHWTriggerEnable_ID;

            unsigned int ui_trigger_mask = 0x00000001;

            for(unsigned int ui_trigger_index = 0; ui_trigger_index < 2; ui_trigger_index++)
            {
                if( IsDlgButtonChecked(IDC_CHECK_TRIGGER_START_RISING_EDGE_0 + ui_trigger_index) == BST_CHECKED )
                {
                    s_adq_hw_trigger_enable.m_uiHWTriggerStartRisingEdge|= ui_trigger_mask;

                    b_wait_start_trigger = 1;
                }
            
                if( IsDlgButtonChecked(IDC_CHECK_TRIGGER_START_FALLING_EDGE_0 + ui_trigger_index) == BST_CHECKED )
                {
                    s_adq_hw_trigger_enable.m_uiHWTriggerStartFallingEdge|= ui_trigger_mask;

                    b_wait_start_trigger = 1;
                }

                if( IsDlgButtonChecked(IDC_CHECK_TRIGGER_STOP_RISING_EDGE_0 + ui_trigger_index) == BST_CHECKED )
                {
                    s_adq_hw_trigger_enable.m_uiHWTriggerStopRisingEdge|= ui_trigger_mask;
                }
            
                if( IsDlgButtonChecked(IDC_CHECK_TRIGGER_STOP_FALLING_EDGE_0 + ui_trigger_index) == BST_CHECKED )
                {
                    s_adq_hw_trigger_enable.m_uiHWTriggerStopFallingEdge|= ui_trigger_mask;
                }

                ui_trigger_mask<<= 1;
            }

            if(IsDlgButtonChecked(IDC_CHECK_DATA_FRAME_PER_TRIGGER) == BST_CHECKED)
            {
                s_adq_hw_trigger_enable.m_bChannelListPerTrigger = true;
            }
            else
            {
                s_adq_hw_trigger_enable.m_bChannelListPerTrigger = false;
            }

            s_adq_hw_trigger_enable.m_bAutomaticRearm = false;
            
            bool b_start_trigger = false;

            if( IsDlgButtonChecked(IDC_CHECK_TRIGGER_START_RISING_EDGE_0) == BST_CHECKED )
            {
                b_start_trigger = true;
            }
            else if( IsDlgButtonChecked(IDC_CHECK_TRIGGER_START_RISING_EDGE_1) == BST_CHECKED )
            {
                b_start_trigger = true;
            }
            else if( IsDlgButtonChecked(IDC_CHECK_TRIGGER_START_FALLING_EDGE_0) == BST_CHECKED )
            {
                b_start_trigger = true;
            }
            else if( IsDlgButtonChecked(IDC_CHECK_TRIGGER_START_FALLING_EDGE_1) == BST_CHECKED )
            {
                b_start_trigger = true;
            }

            bool b_stop_trigger = false;

            if( IsDlgButtonChecked(IDC_CHECK_TRIGGER_STOP_RISING_EDGE_0) == BST_CHECKED )
            {
                b_stop_trigger = true;
            }
            else if( IsDlgButtonChecked(IDC_CHECK_TRIGGER_STOP_RISING_EDGE_1) == BST_CHECKED )
            {
                b_stop_trigger = true;
            }
            else if( IsDlgButtonChecked(IDC_CHECK_TRIGGER_STOP_FALLING_EDGE_0) == BST_CHECKED )
            {
                b_stop_trigger = true;
            }
            else if( IsDlgButtonChecked(IDC_CHECK_TRIGGER_STOP_FALLING_EDGE_1) == BST_CHECKED )
            {
                b_stop_trigger = true;
            }

            if(b_start_trigger & b_stop_trigger)
            {
                if(IsDlgButtonChecked(IDC_CHECK_REARM) == BST_CHECKED)
                {
                    s_adq_hw_trigger_enable.m_bAutomaticRearm = true;
                }
            }

            unsigned int ui_start_trigger_time_out_ms = 0;

            if( (s_adq_hw_trigger_enable.m_uiHWTriggerStartRisingEdge != 0x00000000)||(s_adq_hw_trigger_enable.m_uiHWTriggerStartFallingEdge != 0x00000000) )
            {
                if(IsDlgButtonChecked(IDC_CHECK_START_TRIGGER_TIME_OUT) == BST_CHECKED)
                {
                    ui_start_trigger_time_out_ms = GetDlgItemInt(IDC_EDIT_START_TRIGGER_TIME_OUT);
                }
                else
                {
                    ui_start_trigger_time_out_ms = ADQ_HW_START_TRIGGER_TIMEOUT_INFINITE;
                }
            }

            ui_adq_error = adqEnableHWTrigger(m_parrAIModules[m_uiCurrentModuleIndex].m_uiBoardIndex, m_parrAIModules[m_uiCurrentModuleIndex].m_uiModuleIndex, s_adq_hw_trigger_enable, true, ui_start_trigger_time_out_ms);

            if(ui_adq_error != ADQ_ERROR_NONE)
            {
                cs_message.Format(  _T("adqEnableHWTrigger returned 0x%08X"), 
                                    ui_adq_error                             );

                AfxMessageBox(cs_message, MB_OK | MB_ICONEXCLAMATION);

                return;
            }
        }

         // Update 10 times a second

        unsigned int ui_notify_after_frames = (unsigned int)(d_acheived_freq / 10.0);

        if(m_parrAIModules[m_uiCurrentModuleIndex].m_bSharedDataRate)
        {
            ui_notify_after_frames/= m_uiCurrentNumberOfChannels;
        }

        if(ui_notify_after_frames < 1)
        {
            ui_notify_after_frames = 1;
        }

        CNonModalMessage* p_non_modal_message = NULL;
        
        if(b_wait_start_trigger != 0)
        {
            p_non_modal_message = new CNonModalMessage(this);
        }
        
        ui_adq_error = adqAIReadContinuousStart( m_parrAIModules[m_uiCurrentModuleIndex].m_uiBoardIndex, m_parrAIModules[m_uiCurrentModuleIndex].m_uiModuleIndex, ui_notify_after_frames, 0, PlotCallback, this );

        if(p_non_modal_message != NULL)
        {
            p_non_modal_message->DestroyWindow();
        }

        if(ui_adq_error != ADQ_ERROR_NONE)
        {
            cs_message.Format(  _T("adqAIReadContinuousStart returned 0x%08X"), 
                                ui_adq_error                                    );

            AfxMessageBox(cs_message, MB_OK | MB_ICONEXCLAMATION);

            return;
        }

        _stprintf( &tsz_sampling_rate[0], _T("Actual sampling rate: %12.5f Hz"), d_acheived_freq );
        
        SetDlgItemText( IDC_STATIC_ACTUAL_SAMPLING_RATE, &tsz_sampling_rate[0] );

        m_bAcquisitionRunning = true;
    }

    GetDlgItem(ID_START_STOP)->Invalidate();
}


unsigned int __stdcall CadqSignalScopeDlg :: PlotCallback(unsigned int uiBoardIndex, unsigned int uiModuleIndex, unsigned int uiNumberOfFramesAvailable, unsigned int* puiFrames, unsigned int uiError, void* pvUserContext, unsigned int uiReasonForCall)
{
    CadqSignalScopeDlg* p_dlg = (CadqSignalScopeDlg*)pvUserContext;

    if(uiError != ADQ_ERROR_NONE)
    {
        p_dlg->OnBnClickedStartStop();

        AfxMessageBox( _T("Acquisition terminated") );

        return uiError;
    }

    if( ( (uiReasonForCall & ADQ_CALLED_FOR_DATA) != ADQ_CALLED_FOR_DATA )||(uiNumberOfFramesAvailable == 0) )
    {
        return ADQ_ERROR_NONE;
    }

    CClientDC dc(p_dlg);
    
    dc.IntersectClipRect(p_dlg->m_rectPlot);
    
    CRect rect_erase = p_dlg->m_rectPlot;
    
    CPen* p_old_pen = (CPen*)dc.SelectStockObject(BLACK_PEN);

    if( !p_dlg->m_bFirstDraw )
    {
        dc.MoveTo(p_dlg->m_iXLastPixel + 1, p_dlg->m_rectPlot.top);
        dc.LineTo(p_dlg->m_iXLastPixel + 1, p_dlg->m_rectPlot.bottom);

        int erase_from_pixel = p_dlg->m_iXLastPixel + 1;
        
        int erase_to_pixel = (int)(p_dlg->m_iXLastPixel + (double)uiNumberOfFramesAvailable * p_dlg->m_dXIncrement);

        if(erase_to_pixel > erase_from_pixel)
        {
            if( erase_to_pixel > p_dlg->m_rectPlot.right )
            {
                rect_erase.left = erase_from_pixel;
                
                dc.FillSolidRect( rect_erase, RGB(0, 0, 0) );

                erase_from_pixel = p_dlg->m_rectPlot.left;
                erase_to_pixel-= p_dlg->m_rectPlot.Width();
            }

            rect_erase.left = erase_from_pixel;
                
            rect_erase.right = erase_to_pixel + 2;
                
            dc.FillSolidRect( rect_erase, p_dlg->m_crPlotColor );
        }
    }

    double d_current_pix;
    
    int old_x_pix;
    
    for(unsigned int ui_index_channel = 0; ui_index_channel < p_dlg->m_uiCurrentNumberOfChannels; ui_index_channel++)
    {
            old_x_pix = p_dlg->m_iXLastPixel;
                
            d_current_pix = p_dlg->m_dXLastPixel;
                
            CPen pen_draw( PS_SOLID, 0, p_dlg->m_arrAIChannels[ui_index_channel].m_crPlotColor );
                
            CPen* p_old_draw_pen =  (CPen*)dc.SelectObject(&pen_draw);
        
            for(unsigned long ul_index_frame = 0; ul_index_frame < uiNumberOfFramesAvailable; ul_index_frame++)
            {
                int x_pix = (int)d_current_pix;
                        
                int y_pix = (int)( (double)puiFrames[ul_index_frame * p_dlg->m_uiCurrentNumberOfChannels + ui_index_channel] * p_dlg->m_arrAIChannels[ui_index_channel].m_dDigitalToPixelFactor + p_dlg->m_arrAIChannels[ui_index_channel].m_dDigitalToPixelConstant );

                if( (ul_index_frame == 0)&&(!p_dlg->m_bFirstDraw) )
                {
                    dc.MoveTo(old_x_pix, p_dlg->m_arrAIChannels[ui_index_channel].m_iLastYPixel );
                }

                if(!p_dlg->m_bFirstDraw)
                {
                    if( (x_pix != old_x_pix)||( y_pix != p_dlg->m_arrAIChannels[ui_index_channel].m_iLastYPixel ) )
                    {
                        dc.LineTo(x_pix, y_pix);
                            
                        old_x_pix = x_pix;
                            
                        p_dlg->m_arrAIChannels[ui_index_channel].m_iLastYPixel = y_pix;
                    }
                }
                else
                {
                    dc.MoveTo(x_pix, y_pix);
                        
                    old_x_pix = x_pix;
                        
                    p_dlg->m_arrAIChannels[ui_index_channel].m_iLastYPixel = y_pix;

                    p_dlg->m_bFirstDraw = FALSE;
                }

                d_current_pix+= p_dlg->m_dXIncrement;

                if( (int)d_current_pix > p_dlg->m_rectPlot.right )
                {
                    d_current_pix-= p_dlg->m_rectPlot.Width();

                    old_x_pix-= p_dlg->m_rectPlot.Width();

                    dc.MoveTo(old_x_pix, p_dlg->m_arrAIChannels[ui_index_channel].m_iLastYPixel );
                }
            }

            dc.SelectObject(p_old_draw_pen);
        }

        p_dlg->m_dXLastPixel = d_current_pix;

        p_dlg->m_iXLastPixel = old_x_pix;
        
        p_dlg->m_bFirstDraw = false;
        
        dc.SelectStockObject(WHITE_PEN);

        dc.MoveTo(p_dlg->m_iXLastPixel + 1, p_dlg->m_rectPlot.top);
        dc.LineTo(p_dlg->m_iXLastPixel + 1, p_dlg->m_rectPlot.bottom);

        dc.SelectObject(p_old_pen);

    return ADQ_ERROR_NONE;
}


void CadqSignalScopeDlg::OnBnClickedCheckTriggerStartRisingEdge0()
{
    // TODO: Add your control notification handler code here

    EnableDisableStartTriggerTimeout();

    EnableDisableRearm();
}


void CadqSignalScopeDlg::OnBnClickedCheckTriggerStartRisingEdge1()
{
    // TODO: Add your control notification handler code here

    EnableDisableStartTriggerTimeout();

    EnableDisableRearm();
}


void CadqSignalScopeDlg::OnBnClickedCheckTriggerStartFallingEdge0()
{
    // TODO: Add your control notification handler code here

    EnableDisableStartTriggerTimeout();

    EnableDisableRearm();
}


void CadqSignalScopeDlg::OnBnClickedCheckTriggerStartFallingEdge1()
{
    // TODO: Add your control notification handler code here

    EnableDisableStartTriggerTimeout();

    EnableDisableRearm();
}


void CadqSignalScopeDlg::OnBnClickedCheckStartTriggerTimeOut()
{
    // TODO: Add your control notification handler code here

    bool b_enable = (IsDlgButtonChecked(IDC_CHECK_START_TRIGGER_TIME_OUT) == BST_CHECKED);

    GetDlgItem(IDC_EDIT_START_TRIGGER_TIME_OUT)->EnableWindow(b_enable);
}

void CadqSignalScopeDlg :: EnableDisableStartTriggerTimeout(void)
{
    bool b_enable = false;

    if( IsDlgButtonChecked(IDC_CHECK_TRIGGER_START_RISING_EDGE_0) == BST_CHECKED )
    {
        b_enable = true;
    }
    else if( IsDlgButtonChecked(IDC_CHECK_TRIGGER_START_RISING_EDGE_1) == BST_CHECKED )
    {
        b_enable = true;
    }
    else if( IsDlgButtonChecked(IDC_CHECK_TRIGGER_START_FALLING_EDGE_0) == BST_CHECKED )
    {
        b_enable = true;
    }
    else if( IsDlgButtonChecked(IDC_CHECK_TRIGGER_START_FALLING_EDGE_1) == BST_CHECKED )
    {
        b_enable = true;
    }

    GetDlgItem(IDC_CHECK_DATA_FRAME_PER_TRIGGER)->EnableWindow(b_enable);

    GetDlgItem(IDC_CHECK_START_TRIGGER_TIME_OUT)->EnableWindow(b_enable);

    if(b_enable)
    {
        OnBnClickedCheckStartTriggerTimeOut();
    }
    else
    {
        GetDlgItem(IDC_EDIT_START_TRIGGER_TIME_OUT)->EnableWindow(false);
    }
}

void CadqSignalScopeDlg::OnBnClickedCheckTriggerStopRisingEdge0()
{
    // TODO: Add your control notification handler code here

    EnableDisableRearm();
}


void CadqSignalScopeDlg::OnBnClickedCheckTriggerStopRisingEdge1()
{
    // TODO: Add your control notification handler code here

    EnableDisableRearm();
}


void CadqSignalScopeDlg::OnBnClickedCheckTriggerStopFallingEdge0()
{
    // TODO: Add your control notification handler code here

    EnableDisableRearm();
}


void CadqSignalScopeDlg::OnBnClickedCheckTriggerStopFallingEdge1()
{
    // TODO: Add your control notification handler code here

    EnableDisableRearm();
}

void CadqSignalScopeDlg :: EnableDisableRearm(void)
{
    bool b_start_trigger = false;

    if( IsDlgButtonChecked(IDC_CHECK_TRIGGER_START_RISING_EDGE_0) == BST_CHECKED )
    {
        b_start_trigger = true;
    }
    else if( IsDlgButtonChecked(IDC_CHECK_TRIGGER_START_RISING_EDGE_1) == BST_CHECKED )
    {
        b_start_trigger = true;
    }
    else if( IsDlgButtonChecked(IDC_CHECK_TRIGGER_START_FALLING_EDGE_0) == BST_CHECKED )
    {
        b_start_trigger = true;
    }
    else if( IsDlgButtonChecked(IDC_CHECK_TRIGGER_START_FALLING_EDGE_1) == BST_CHECKED )
    {
        b_start_trigger = true;
    }

    bool b_stop_trigger = false;

    if( IsDlgButtonChecked(IDC_CHECK_TRIGGER_STOP_RISING_EDGE_0) == BST_CHECKED )
    {
        b_stop_trigger = true;
    }
    else if( IsDlgButtonChecked(IDC_CHECK_TRIGGER_STOP_RISING_EDGE_1) == BST_CHECKED )
    {
        b_stop_trigger = true;
    }
    else if( IsDlgButtonChecked(IDC_CHECK_TRIGGER_STOP_FALLING_EDGE_0) == BST_CHECKED )
    {
        b_stop_trigger = true;
    }
    else if( IsDlgButtonChecked(IDC_CHECK_TRIGGER_STOP_FALLING_EDGE_1) == BST_CHECKED )
    {
        b_stop_trigger = true;
    }

    GetDlgItem(IDC_CHECK_REARM)->ShowWindow( (b_start_trigger & b_stop_trigger) ? SW_SHOW : SW_HIDE );
}
