
// adqSignalScopeDlg.h : header file
//

#pragma once


#include "..\\adqDevice.h"

#ifdef WIN64

#pragma comment(lib, "..\\adqDevice_64.lib")

#else

#pragma comment(lib, "..\\adqDevice.lib")

#endif


    const COLORREF m_crDefaultSignalColor[8] = {    RGB(0x0FF, 0x00, 0x00),
                                                    RGB(0x00, 0x0FF, 0x00),
                                                    RGB(0x00, 0x00, 0xFF),
                                                    RGB(0xFF, 0xFF, 0x00),
                                                    RGB(0xFF, 0x00, 0xFF),
                                                    RGB(0x00, 0xFF, 0xFF),
                                                    RGB(0x80, 0x80, 0x80),
                                                    RGB(0xFF, 0xFF, 0xFF)   };

// CadqSignalScopeDlg dialog
class CadqSignalScopeDlg : public CDialogEx
{
// Construction
public:
    CadqSignalScopeDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
    enum { IDD = IDD_ADQSIGNALSCOPE_DIALOG };

    protected:
    virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
    HICON m_hIcon;

    // Generated message map functions
    virtual BOOL OnInitDialog();
    afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
    afx_msg void OnPaint();
    afx_msg HCURSOR OnQueryDragIcon();
    DECLARE_MESSAGE_MAP()
public:
    afx_msg void OnBnClickedCheckChannel0();
    afx_msg void OnBnClickedCheckChannel1();
    afx_msg void OnBnClickedCheckChannel2();
    afx_msg void OnBnClickedCheckChannel3();
    afx_msg void OnBnClickedCheckChannel4();
    afx_msg void OnBnClickedCheckChannel5();
    afx_msg void OnBnClickedCheckChannel6();
    afx_msg void OnBnClickedCheckChannel7();
    afx_msg void OnCbnSelchangeComboModules();
    afx_msg void OnBnClickedSignalColor0();
    afx_msg void OnBnClickedSignalColor1();
    afx_msg void OnBnClickedSignalColor2();
    afx_msg void OnBnClickedSignalColor3();
    afx_msg void OnBnClickedSignalColor4();
    afx_msg void OnBnClickedSignalColor5();
    afx_msg void OnBnClickedSignalColor6();
    afx_msg void OnBnClickedSignalColor7();
    afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct);
    afx_msg void OnBnClickedStartStop();
    afx_msg void OnBnClickedCheckTriggerStartRisingEdge0();
    afx_msg void OnBnClickedCheckTriggerStartRisingEdge1();
    afx_msg void OnBnClickedCheckTriggerStartFallingEdge0();
    afx_msg void OnBnClickedCheckTriggerStartFallingEdge1();
    afx_msg void OnBnClickedCheckStartTriggerTimeOut();
    afx_msg void OnBnClickedCheckTriggerStopRisingEdge0();
    afx_msg void OnBnClickedCheckTriggerStopRisingEdge1();
    afx_msg void OnBnClickedCheckTriggerStopFallingEdge0();
    afx_msg void OnBnClickedCheckTriggerStopFallingEdge1();

private:

    unsigned int m_uiNumberOfModules; 

    struct SAIModule
    {
        unsigned int    m_uiBoardIndex;

        wchar_t         m_wszBoardName[64];

        unsigned int    m_uiModuleIndex;

        unsigned int    m_uiNumberOfChannels;

        bool            m_bSharedDataRate;

        bool            m_bRangeInfoPerChannel;

        unsigned int    m_uiNumberOfRanges;

        SADQAIRange     m_arrRanges[ADQ_MAX_AI_RANGES];

        unsigned int    m_uiHWTriggerStartSource;

        unsigned int    m_uiHWTriggerStopSource;

        unsigned int    m_bSupportsChannelListPerTrigger;
    }
    *m_parrAIModules;

    unsigned int m_uiCurrentModuleIndex;

    COLORREF m_crPlotColor;

    bool m_bAcquisitionRunning;

    struct SAIChannel
    {
        unsigned int    m_uiChannelIndex;

        COLORREF        m_crPlotColor;

        double          m_dDigitalToPixelFactor;

        double          m_dDigitalToPixelConstant;

        int             m_iLastYPixel;
    }
    m_arrAIChannels[8];

    unsigned int m_uiCurrentNumberOfChannels;

    CRect m_rectPlot;

    double	m_dWindowWidthSec;

    // Internal variables

    bool m_bFirstDraw;
    
    double m_dXIncrement;
    
    double	m_dXLastPixel;
    
    int		m_iXLastPixel;

    void OnBnClickedCheckChannel(unsigned int uiChannelIndex);

    void OnBnClickedSignalColor(unsigned int uiChannelIndex);

    void CadqSignalScopeDlg :: EnableDisableStartTriggerTimeout(void);

    void CadqSignalScopeDlg :: EnableDisableRearm(void);

    unsigned int static __stdcall PlotCallback(unsigned int uiBoardIndex, unsigned int uiModuleIndex, unsigned int uiNumberOfFramesAvailable, unsigned int* puiFrames, unsigned int uiError, void* pvUserContext, unsigned int uiReasonForCall);
};
