#include <windows.h>

#include <stdio.h>
#include <stdlib.h>

#include <tchar.h>

#include <conio.h>

#include "..\\adqDevice.h"

#ifdef WIN64

#pragma comment(lib, "..\\adqDevice_64.lib")

#else

#pragma comment(lib, "..\\adqDevice.lib")

#endif

struct SFINModule
{
    unsigned int    m_uiBoardIndex;

    unsigned int    m_uiModuleIndex;
};

int _tmain(int argc, _TCHAR* argv[])
{
   // Increase the size of the console buffer
    
    HANDLE  h_console = GetStdHandle(STD_OUTPUT_HANDLE);

    COORD coord;

    coord.X = 160;
    
    coord.Y = 9999;
    
    SetConsoleScreenBufferSize(h_console, coord);

    bool b_terminate = false;

    bool b_remote = false;

    wchar_t wsz_remote_name_or_IP_address[128];

    while(true)
    {
        printf( "1. Open local\n"
                "2. Open remote\n"
                "\n"
                "Your choice: 1 or 2 (RETURN to exit): ");

        char sz_response[8];

        gets_s(&sz_response[0], 8);

        printf("\n\n");

        if(sz_response[0] == 0)
        {
            b_terminate = true;
            
            break;
        }

        unsigned int ui_choice = 0;

        if( sscanf_s(&sz_response[0], "%u", &ui_choice) != 1)
        {
            continue;
        }

        if(ui_choice == 1)
        {
            break;
        }

        if(ui_choice == 2)
        {
            b_remote = true;

            printf("Name or IP-Address (RETURN to exit): ");

            _getws_s(&wsz_remote_name_or_IP_address[0], 128);

            printf("\n\n");

            if( wsz_remote_name_or_IP_address[0] == (wchar_t)0 )
            {
                b_terminate = true;
            }

            break;
        }
    }

    if(b_terminate)
    {
        printf("Press any key to exit.\n");

        _getch();

        exit(-1);
    }

    unsigned int ui_adq_error;
    
    if(b_remote)
    {
        wchar_t* pwc_user_name_or_address[2] = {&wsz_remote_name_or_IP_address[0],
                                                NULL                                };

        ui_adq_error = adqOpenEx(pwc_user_name_or_address);

        if(ui_adq_error != ADQ_ERROR_NONE)
        {
            printf("!!!! Error - adqOpenEx returned error code 0x%08X\n\n", ui_adq_error);

            printf("Press any key to exit.\n");

            _getch();

            exit(-1);
        }
    }
    else
    {
        ui_adq_error = adqOpen();

        if(ui_adq_error != ADQ_ERROR_NONE)
        {
            printf("!!!! Error - adqOpen returned error code 0x%08X\n\n", ui_adq_error);

            printf("Press any key to exit.\n");

            _getch();

            exit(-1);
        }
    }

    unsigned int ui_number_of_boards;
    
    ui_adq_error = adqGetNumberOfBoards(ui_number_of_boards);

    if(ui_adq_error != ADQ_ERROR_NONE)
    {
        printf("!!!! Error - adqGetNumberOfBoards returned error code 0x%08X\n\n", ui_adq_error);

        printf("Press any key to exit.\n");

        adqClose();

        _getch();

        exit(-1);
    }

    if(ui_number_of_boards == 0)
    {
        printf("No ADQ boards found!\n\n");

        printf("Press any key to exit.\n");

        adqClose();

        _getch();

        exit(-1);
    }

    printf("%3u ADQ Boards found\n\n", ui_number_of_boards);

    // Count the number of FIN modules

    unsigned int ui_number_of_fin_modules = 0;

    for(unsigned int ui_index_board = 0; ui_index_board < ui_number_of_boards; ui_index_board++)
    {
        unsigned int ui_number_of_modules;

        ui_adq_error = adqGetNumberOfModules(ui_index_board, ui_number_of_modules);

        if(ui_adq_error != ADQ_ERROR_NONE)
        {
            printf("!!!! Error -     Board index: %3u adqGetNumberOfModules returned error code 0x%08X\n\n", ui_index_board, ui_adq_error);

            printf("Press any key to continue.\n");

            _getch();

            continue;
        }

        for(unsigned int ui_index_module = 0; ui_index_module < ui_number_of_modules; ui_index_module++)
        {
            unsigned int ui_module_type;

            ui_adq_error = adqGetModuleType(ui_index_board, ui_index_module, ui_module_type);

            if(ui_adq_error != ADQ_ERROR_NONE)
            {
                printf("!!!! Error -         Board index: %3u Module index: %3u adqGetModuleType returned error code 0x%08X\n\n", ui_index_board, ui_index_module, ui_adq_error);

                printf("Press any key to continue.\n");

                _getch();

                continue;
            }

            if(ui_module_type == ADQ_MODULE_TYPE_FIN)
            {
                ++ui_number_of_fin_modules;
            }
        }
    }

    if(ui_number_of_fin_modules == 0)
    {
        printf("No FIN modules found!\n\n");

        printf("Press any key to exit.\n");

        adqClose();

        _getch();

        exit(-1);
    }

    unsigned int ui_max_number_of_fin_modules = ui_number_of_fin_modules;

    SFINModule* arr_fin_modules = new SFINModule[ui_max_number_of_fin_modules];

    ui_number_of_fin_modules = 0;

    for(unsigned int ui_index_board = 0; ui_index_board < ui_number_of_boards; ui_index_board++)
    {
        unsigned int ui_number_of_modules;

        ui_adq_error = adqGetNumberOfModules(ui_index_board, ui_number_of_modules);

        if(ui_adq_error != ADQ_ERROR_NONE)
        {
            printf("!!!! Error -     Board index: %3u adqGetNumberOfModules returned error code 0x%08X\n\n", ui_index_board, ui_adq_error);

            printf("Press any key to continue.\n");

            _getch();

            continue;
        }

        for(unsigned int ui_index_module = 0; ui_index_module < ui_number_of_modules; ui_index_module++)
        {
            unsigned int ui_module_type;

            ui_adq_error = adqGetModuleType(ui_index_board, ui_index_module, ui_module_type);

            if(ui_adq_error != ADQ_ERROR_NONE)
            {
                printf("!!!! Error -         Board index: %3u Module index: %3u adqGetModuleType returned error code 0x%08X\n\n", ui_index_board, ui_index_module, ui_adq_error);

                printf("Press any key to continue.\n");

                _getch();

                continue;
            }

            SADQGeneralModuleInfo s_adq_general_module_info;

            s_adq_general_module_info.m_uiSize = sizeof(SADQGeneralModuleInfo);

            s_adq_general_module_info.m_uiID = SADQGeneralModuleInfo_ID;

            if(ui_module_type == ADQ_MODULE_TYPE_FIN)
            {
                arr_fin_modules[ui_number_of_fin_modules].m_uiBoardIndex = ui_index_board;

                arr_fin_modules[ui_number_of_fin_modules].m_uiModuleIndex = ui_index_module;

                ++ui_number_of_fin_modules;
            }
        }
    }

    while(true)
    {
        printf("Please choose a module:\n\n");

        unsigned int ui_index_fin_module;

        for(ui_index_fin_module = 0; ui_index_fin_module < ui_number_of_fin_modules; ui_index_fin_module++)
        {
            printf("%2u.  Board index: %2d  Module index: %2d\n",
                   ui_index_fin_module + 1,
                   arr_fin_modules[ui_index_fin_module].m_uiBoardIndex,
                   arr_fin_modules[ui_index_fin_module].m_uiModuleIndex                                          );
        }

        printf("\n");

        printf("Your choice 1 - %d (RETURN to exit): ",
               ui_number_of_fin_modules             );

        char sz_response[32];

        gets_s(&sz_response[0], 32);

        printf("\n\n");

        if(sz_response[0] == 0)
        {
            break;
        }

        if( sscanf_s(&sz_response[0], "%u", &ui_index_fin_module) != 1)
        {
            continue;
        }

        if( (ui_index_fin_module < 1)||(ui_index_fin_module > ui_number_of_fin_modules) )
        {
            continue;
        }

        --ui_index_fin_module;

        printf("Time-out in milliseconds (Return to exit): ");

        gets_s(&sz_response[0], 32);

        printf("\n\n");

        if(sz_response[0] == 0)
        {
            break;
        }

        unsigned int ui_time_out_milliseconds;

        if( sscanf_s(&sz_response[0], "%u", &ui_time_out_milliseconds) != 1)
        {
            continue;
        }

        for( ; ; )
        {
            printf("Press any key to read from FIN module (ESC to cancel): " );

            char ch_user = _getch();

            printf("\n\n");

            if(ch_user == 27)
            {
                break;
            }

            double d_frequency;

            double d_on_time;
            
            ui_adq_error = adqFINRead(  arr_fin_modules[ui_index_fin_module].m_uiBoardIndex,
                                        arr_fin_modules[ui_index_fin_module].m_uiModuleIndex,
                                        d_frequency,
                                        d_on_time,
                                        ui_time_out_milliseconds                                );

            if(ui_adq_error == ADQ_ERROR_TIMEOUT)
            {
                printf( "!!!! Error -         Board index: %3u Module index: %3u adqReadFIN timed out\n\n", 
                        arr_fin_modules[ui_index_fin_module].m_uiBoardIndex, 
                        arr_fin_modules[ui_index_fin_module].m_uiModuleIndex, 
                        ui_adq_error                                                                       );

                printf("Press any key to continue.\n\n");

                _getch();

                continue;
            }
            else if(ui_adq_error != ADQ_ERROR_NONE)
            {
                printf( "!!!! Error -         Board index: %3u Module index: %3u adqReadFIN returned error code 0x%08X\n\n", 
                        arr_fin_modules[ui_index_fin_module].m_uiBoardIndex, 
                        arr_fin_modules[ui_index_fin_module].m_uiModuleIndex, 
                        ui_adq_error                                                                                        );

                printf("Press any key to continue.\n\n");

                _getch();

                continue;
            }

            printf("Read from FIN - Frequency: %14.5f Hz    Time on: %14.9 seconds\n\n", d_frequency, d_on_time);

            printf("Press any key to continue\n\n");

            _getch();
        }

        printf("Press any key to continue\n\n");

        _getch();
    }

    delete []arr_fin_modules;

    adqClose();

    printf("\n\n");

    printf("Press any key to terminate.\n");

    _getch();

    return 0;
}

