//-----------------------------------------------------------------------------
// ALLDAQ, a division of ALLNET GmbH
// https://www.alldaq.com
//
// Purpose:
//       This file is part of the adqWriteContinuousCallback project of the ALLDAQ-SDK.  
//       It shows the usage of the API functions to access
//       ALLDAQ Data Acquisition Boards
// 
//-----------------------------------------------------------------------------

#include "stdafx.h"
#include "SawtoothFallingWaveGenerator.h"


SawtoothFallingWaveGenerator::SawtoothFallingWaveGenerator()
{
}

SawtoothFallingWaveGenerator::~SawtoothFallingWaveGenerator()
{
}

std::wstring SawtoothFallingWaveGenerator::GetGeneratorName()
{
    return L"Saw-tooth falling";
}

double SawtoothFallingWaveGenerator::GetValue(double cycleTime, double signalMaximum)
{
    return signalMaximum - 2.0 * signalMaximum * cycleTime;
}
