//-----------------------------------------------------------------------------
// ALLDAQ, a division of ALLNET GmbH
// https://www.alldaq.com
//
// Purpose:
//       This file is part of the adqWriteContinuousCallback project of the ALLDAQ-SDK.  
//       It shows the usage of the API functions to access
//       ALLDAQ Data Acquisition Boards
// 
//-----------------------------------------------------------------------------

#include "stdafx.h"
#include "TriangleWaveGenerator.h"


TriangleWaveGenerator::TriangleWaveGenerator()
{
}

TriangleWaveGenerator::~TriangleWaveGenerator()
{
}

std::wstring TriangleWaveGenerator::GetGeneratorName()
{
    return L"Triangle";
}

double TriangleWaveGenerator::GetValue(double cycleTime, double signalMaximum)
{
    if (cycleTime <= 0.5)
    {
        return 4.0 * signalMaximum * cycleTime - signalMaximum;
    }
    else
    {
        return signalMaximum - 4.0 * signalMaximum * (cycleTime - 0.5);
    }
}
