//-----------------------------------------------------------------------------
// ALLDAQ, a division of ALLNET GmbH
// https://www.alldaq.com
//
// Purpose:
//       This file is part of the adqWriteContinuousWithoutCallback project of the ALLDAQ-SDK.  
//       It shows the usage of the API functions to access
//       ALLDAQ Data Acquisition Boards
// 
//-----------------------------------------------------------------------------

#include "stdafx.h"
#include "SawtoothRisingWaveGenerator.h"


SawtoothRisingWaveGenerator::SawtoothRisingWaveGenerator()
{
}

SawtoothRisingWaveGenerator::~SawtoothRisingWaveGenerator()
{
}

std::wstring SawtoothRisingWaveGenerator::GetGeneratorName()
{
    return L"Saw-tooth rising";
}

double SawtoothRisingWaveGenerator::GetValue(double cycleTime, double signalMaximum)
{
    return 2.0 * signalMaximum * cycleTime - signalMaximum;
}
