//-----------------------------------------------------------------------------
// ALLDAQ, a division of ALLNET GmbH
// https://www.alldaq.com
//
// Purpose:
//       This file is part of the adqWriteContinuousWithoutCallback project of the ALLDAQ-SDK.  
//       It shows the usage of the API functions to access
//       ALLDAQ Data Acquisition Boards
// 
//-----------------------------------------------------------------------------

#include "stdafx.h"
#include "SquareWaveGenerator.h"


SquareWaveGenerator::SquareWaveGenerator()
{
}

SquareWaveGenerator::~SquareWaveGenerator()
{
}

std::wstring SquareWaveGenerator::GetGeneratorName()
{
    return L"Square Wave";
}

double SquareWaveGenerator::GetValue(double cycleTime, double signalMaximum)
{
    return (cycleTime <= 0.5) ? -signalMaximum : signalMaximum;
}
